var motivosAc = [];
var loaded = false;
controllers.controller('cadastroVisitaCtrl', ['$scope', '$state', 'DB', '$stateParams', '$ionicLoading', '$ionicPopup', '$q', '$ionicPlatform', 'temporario', '$cordovaGeolocation', '$cordovaDevice', 'storageService',
  function ($scope, $state, DB, $stateParams, $ionicLoading, $ionicPopup, $q, $ionicPlatform, temporario, $cordovaGeolocation, $cordovaDevice, storageService) {
    $scope.verBotaoVoltar = true;
    $scope.verBotaoSalvar = true;

    function _diffYears(data2, data1) {

      var diff = (data2 - data1) / 1000;
      diff /= (60 * 60 * 24);
      return Math.abs(Math.round(diff / 365.25));

    }
    var _IsIndividuoValido = function (item) {
      if(!item){
        return false;
      }
      if($scope.domicilio.individuos){
        $scope.domicilio.individuos.forEach(function (element){
          if(element.id ===item.id){
            item = element;
            return;
          }
        });
      }
      if(!item.dataNascimento){
        return false;
      }
      var _dataNascimento = item.dataNascimento.split("/");
      _dataNascimento = new Date(_dataNascimento[2], _dataNascimento[1] - 1, _dataNascimento[0]);
      console.log(_diffYears(_dataNascimento.getTime(), new Date().getTime()))
      if (_diffYears(_dataNascimento.getTime(), new Date().getTime()) > 130) {
        
        $scope.messagePopup("Data de Nascimento não pode ser anterior a 130 anos a partir da data de Visita. Corrija a data de nascimento do indivíduo ou a data atual do dispositivo para continuar.").then(function () {
          $scope.salvarTemporario();
          $state.go('cadastroIndividuos.tabIdentificacao', {
            idIndividuo: item.id
          });
        });

        return true;
      }
      if (_dataNascimento.getTime() >= new Date().getTime()) {
        $scope.messagePopup("A data da Visita não pode ser anterior a Data de Nascimento. Corrija a data de nascimento do indivíduo ou a data atual do dispositivo para continuar.").then(function () {
          $scope.salvarTemporario();
          $state.go('cadastroIndividuos.tabIdentificacao', {
            idIndividuo: item.id
          });
        });

        return true;

      }

      return false;
    };

    $ionicLoading.show({
      template: 'Carregando...'
    });
    $scope.bind = {
      notificacoes: ""
    };

    $scope.tituloPrincipal = 'Cadastro de Visita';
    $scope.usuario = JSON.parse(window.localStorage.getItem('usuarioLogado'));
    $scope.bind.idDomicilio = $stateParams.idDomicilio;

    $scope.domicilio = {};

    $scope.limpar = function () {
      $scope.bind.codigoPesquisa = null;
      $scope.bind.perguntas = null;
      $scope.visita = {
        compartilhada: 0,
        motivoAtualizacao: 0,
        motivoVisitaPeriodica: 0,
        motivoBaConsulta: 0,
        motivoBaExame: 0,
        motivoBaVacina: 0,
        motivoBaCondicionalidadesBolsaFamilia: 0,
        motivoAcGestante: 0,
        motivoAcPuerpera: 0,
        motivoAcRecemNascido: 0,
        motivoAcCrianca: 0,
        motivoAcPessoaDesnutrida: 0,
        motivoAcPessoaDeficiente: 0,
        motivoAcPessoaHipertensa: 0,
        motivoAcPessoaDiabetes: 0,
        motivoAcPessoaAsmatica: 0,
        motivoAcPessoaEnfisema: 0,
        motivoAcPessoaCancer: 0,
        motivoAcPessoaDoencaCronica: 0,
        motivoAcPessoaHanseniase: 0,
        motivoAcPessoaTuberculose: 0,
        motivoAcAcamado: 0,
        motivoAcVulnerabilidadeSocial: 0,
        motivoAcCondicionalidadesBolsaFamilia: 0,
        motivoAcSaudeMental: 0,
        motivoAcUsuarioAlcool: 0,
        motivoAcUsuarioDroga: 0,
        motivoEgressoInternacao: 0,
        motivoControleAmbientesVetores: 0,
        motivoCampanhaSaude: 0,
        motivoPrevencao: 0,
        motivoOutros: 0,
        motivoSintomaticosRespiratorios: 0,
        motivoTabagista: 0,
        motivoAcaoEducativa: 0,
        motivoImovelComFoco: 0,
        motivoAcaoMecanica: 0,
        motivoTratamentoFocal: 0
      };
    };
    $scope.limpar();

    if (storageService.getItem('tmpVisita')) {
      $scope.visita = angular.copy(JSON.parse(storageService.getItem('tmpVisita')));
      storageService.removeItem('tmpVisita');
    }

    $scope.salvarTemporario = function () {
      var temporario = {
        visita: $scope.visita,
        bind: $scope.bind,
        domicilio: $scope.domicilio
      };
      window.localStorage.setItem("tempVisita", JSON.stringify(temporario));
    };

    $scope.acaoVoltar = function () {
      $state.go('visitas');
    };

    $scope.carregarDomicilio = function () {
      DB.query("SELECT d.id," +
        " d.numeroFamilia, " +
        " d.codigoMicroArea, " +
        " d.codigoSistema, " +
        " tipLog.id AS codigoTipoLogradouro, " +
        " tipLog.descricao AS descricaoTipoLogradouro, " +
        " end.id AS codigoEndereco, " +
        " end.logradouro, " +
        " end.bairro, " +
        " end.numeroLogradouro, " +
        " end.codigoCidade, " +
        " end.complementoLogradouro, " +
        " end.pontoReferencia, " +
        " cast(end.cep as number) AS cep, " +
        " end.telefone, " +
        " end.telefoneReferencia " +
        " FROM domicilio AS d " +
        "  left outer join endereco AS end ON d.codigoEndereco = end.id " +
        "  left outer join tipoLogradouro AS tipLog ON end.codigoTipoLogradouro = tipLog.id " +
        " WHERE d.id = ?", [$scope.bind.idDomicilio]).then(function (result) {

        var domicilio = DB.fetch(result);
        $scope.domicilio = domicilio;

        $scope.carregarDomicilioEsus();
      }, function (err) {
        console.error(err.message);
      });
    };

    $scope.carregarDomicilioEsus = function () {
      DB.query("SELECT d.*" +
        " FROM domicilioEsus AS d " +
        " WHERE d.codigoDomicilio = ?", [$scope.bind.idDomicilio]).then(function (result) {

        var domicilioEsus = DB.fetch(result);
        $scope.domicilioEsus = domicilioEsus;

        if (domicilioEsus) {
          $scope.disabledField = domicilioEsus.tipoImovel == 2 || domicilioEsus.tipoImovel == 3 || domicilioEsus.tipoImovel == 4 || domicilioEsus.tipoImovel == 5 || domicilioEsus.tipoImovel == 6 || domicilioEsus.tipoImovel == 12;
        }

        $scope.carregarIndividuos();
      }, function (err) {
        console.error(err.message);
      });
    };

    function pad(num, size) {
      var s = num + "";
      while (s.length < size) s = "0" + s;
      return s;
    }

    $scope.carregarIndividuos = function () {
      DB.query("SELECT p.id," +
        " p.nome, " +
        " p.sexo, " +
        " p.nomeMae, " +
        " (strftime('%Y', 'now') - strftime('%Y', dataNascimento, 'unixepoch')) - (strftime('%m-%d', 'now') < strftime('%m-%d', dataNascimento, 'unixepoch')) AS idadeAnos, " +
        " pd.id AS idPacienteDado, " +
        " CAST(pd.peso AS FLOAT) / CAST(1000 AS float) AS peso, " +
        " pd.altura, " +
        " CAST(pd.peso AS FLOAT) / CAST(1000 AS float) AS pesoOriginal, " +
        " pd.altura AS alturaOriginal, " +
        " strftime('%d/%m/%Y',p.dataNascimento, 'unixepoch') AS dataNascimento, " +
        " (select cns.id from cns AS cns where cns.codigoPaciente = p.id and cns.excluido = 'N' order by cns.numeroCartao limit 1) AS cnsId " +
        " FROM paciente AS p " +
        " LEFT JOIN pacienteDado pd ON p.id = pd.codigoPaciente " +
        " WHERE p.codigoDomicilio = ?", [$scope.bind.idDomicilio]).then(function (result) {

        var individuos = DB.fetchAll(result);

        $scope.domicilio.individuos = individuos;

        if (individuos.length > 0) {
          $scope.carregarNotificacoes(individuos);
        } else {
          $ionicLoading.hide();
        }
      }, function (err) {
        console.error(err.message);
      });
    };

    $scope.carregarNotificacoes = function (individuos) {
      var binding = [];
      var sql = "SELECT p.id AS codigoPaciente, n.vacinaAtrasada, p.registroVacina " +
        " FROM paciente AS p LEFT JOIN notificacaoPaciente AS n ON p.id = n.codigoPaciente " +
        " WHERE p.id in (";
      for (var i = 0; i < individuos.length; i++) {
        binding.push(individuos[i].id);
        sql += "?,";
      }
      sql = sql.substring(0, sql.length - 1) + ")";

      DB.query(sql, binding).then(function (result) {

        var notificaveis = DB.fetchAll(result);
        var nNotificaveis = 0;
        for (var j = 0; j < $scope.domicilio.individuos.length; j++) {
          for (var i = 0; i < notificaveis.length; i++) {
            if (notificaveis[i].codigoPaciente == $scope.domicilio.individuos[j].id) {
              if (notificaveis[i].registroVacina != 1) {
                if (isValid(notificaveis[i].vacinaAtrasada)) {
                  $scope.domicilio.individuos[j].vacinaAtrasada = notificaveis[i].vacinaAtrasada;
                  if (notificaveis[i].vacinaAtrasada != 0) {
                    nNotificaveis++;
                  }
                } else {
                  nNotificaveis++;
                  $scope.domicilio.individuos[j].vacinaAtrasada = -1;
                }
              }
              break;
            }
          }
        }
        $scope.carregarNotificacoesAgenda(individuos, nNotificaveis);
      }, function (err) {
        console.error(err.message);
      });
    };

    $scope.carregarNotificacoesAgenda = function (individuos, nNotificaveis) {
      var binding = [];
      var sql = "SELECT n.codigoPaciente FROM notificacaoAgendas AS n WHERE n.status = 1 AND n.codigoPaciente in (";
      for (var i = 0; i < individuos.length; i++) {
        binding.push(individuos[i].id);
        sql += "?,";
      }
      sql = sql.substring(0, sql.length - 1) + ") group by n.codigoPaciente";

      DB.query(sql, binding).then(function (result) {

        var notificaveis = DB.fetchAll(result);
        if (notificaveis) {
          for (var i = 0; i < notificaveis.length; i++) {
            for (var j = 0; j < $scope.domicilio.individuos.length; j++) {
              if (notificaveis[i].codigoPaciente == $scope.domicilio.individuos[j].id) {
                $scope.domicilio.individuos[j].naoComparecimento = 1;
                nNotificaveis++;
              }
            }
          }
        }
        if (nNotificaveis > 0) {
          $scope.bind.notificacoes = nNotificaveis;
        }

        $ionicLoading.hide();
      }, function (err) {
        console.error(err.message);
      });
    };

    $scope.showConfirmation = function (mensagem) {
      var deferred = $q.defer();
      var alertPopup = $ionicPopup.confirm({
        title: 'Atenção!',
        template: mensagem,
        buttons: [{
          text: 'Não'
        }, {
          text: '<b>Sim</b>',
          type: 'button-positive',
          onTap: function (e) {
            return true;
          }
        }]
      });
      alertPopup.then(function (resposta) {
        return deferred.resolve(resposta);
      });

      return deferred.promise;
    };

    $scope.messagePopup = function (msg) {
      $ionicLoading.hide();
      var deferred = $q.defer();

      //https://github.com/driftyco/ionic/blob/master/js/angular/service/platform.js  TO VIEW PRIORITY LIST
      var deregisterBackEvent = $ionicPlatform.registerBackButtonAction(function () {}, 501);

      $ionicPopup.alert({
        title: 'Atenção!',
        template: msg
      }).then(function () {
        deregisterBackEvent();
        deferred.resolve();
      });

      return deferred.promise;
    };

    $scope.acaoSalvar = function () {
      $ionicLoading.show({
        template: 'Salvando...'
      });
      try {
        if (isInvalid($scope.domicilio.numeroFamilia)) {
          $scope.messagePopup("Antes de efetuar a visita, informe o número da familia para o domicílio " + $scope.domicilio.codigoSistema).then(function () {
            $state.go('cadastroDomicilios.tabEndereco', {
              'idDomicilio': $scope.bind.idDomicilio,
              'visitas': true
            });
            storageService.setItem("tmpVisita", JSON.stringify($scope.visita));
          });
          return;
        }

        if (!$scope.disabledField && $scope.visita.desfecho === 1 && isInvalid($scope.visita.codigoIndividuo)) {
          throw "Informe o Indivíduo";
        }

        var _fakeIndividuo = {};
        _fakeIndividuo.id = $scope.visita.codigoIndividuo;
        if(_IsIndividuoValido(_fakeIndividuo)){
          return;
        }

        if ($scope.visita.motivoAtualizacao === 0 &&
          $scope.visita.motivoVisitaPeriodica === 0 &&
          $scope.visita.motivoBaConsulta === 0 &&
          $scope.visita.motivoBaExame === 0 &&
          $scope.visita.motivoBaVacina === 0 &&
          $scope.visita.motivoBaCondicionalidadesBolsaFamilia === 0 &&
          $scope.visita.motivoAcGestante === 0 &&
          $scope.visita.motivoAcPuerpera === 0 &&
          $scope.visita.motivoAcRecemNascido === 0 &&
          $scope.visita.motivoAcCrianca === 0 &&
          $scope.visita.motivoAcPessoaDesnutrida === 0 &&
          $scope.visita.motivoAcPessoaDeficiente === 0 &&
          $scope.visita.motivoAcPessoaHipertensa === 0 &&
          $scope.visita.motivoAcPessoaDiabetes === 0 &&
          $scope.visita.motivoAcPessoaAsmatica === 0 &&
          $scope.visita.motivoAcPessoaEnfisema === 0 &&
          $scope.visita.motivoAcPessoaCancer === 0 &&
          $scope.visita.motivoAcPessoaDoencaCronica === 0 &&
          $scope.visita.motivoAcPessoaHanseniase === 0 &&
          $scope.visita.motivoAcPessoaTuberculose === 0 &&
          $scope.visita.motivoAcAcamado === 0 &&
          $scope.visita.motivoAcVulnerabilidadeSocial === 0 &&
          $scope.visita.motivoAcCondicionalidadesBolsaFamilia === 0 &&
          $scope.visita.motivoAcSaudeMental === 0 &&
          $scope.visita.motivoAcUsuarioAlcool === 0 &&
          $scope.visita.motivoAcUsuarioDroga === 0 &&
          $scope.visita.motivoEgressoInternacao === 0 &&
          $scope.visita.motivoControleAmbientesVetores === 0 &&
          $scope.visita.motivoCampanhaSaude === 0 &&
          $scope.visita.motivoPrevencao === 0 &&
          $scope.visita.motivoOutros === 0 &&
          $scope.visita.motivoSintomaticosRespiratorios === 0 &&
          $scope.visita.motivoTabagista === 0 &&
          $scope.visita.motivoAcaoEducativa === 0 &&
          $scope.visita.motivoImovelComFoco === 0 &&
          $scope.visita.motivoAcaoMecanica === 0 &&
          $scope.visita.motivoTratamentoFocal === 0) {

          throw "Informe pelo menos um Motivo";
        }

        //verifica o motivo da visita, se for AcGestante ou AcPuerpera só pode ser para mulher e em visita não compartilhada
        if ((!isInvalid($scope.visita.motivoAcGestante) && $scope.visita.motivoAcGestante !== 0) || (!isInvalid($scope.visita.motivoAcPuerpera) && $scope.visita.motivoAcPuerpera !== 0)) {
          for (var i = 0; i < $scope.domicilio.individuos.length; i++) {
            var individuo = $scope.domicilio.individuos[i];
            if (individuo.id == $scope.visita.codigoIndividuo && individuo.sexo == 'M') {
              throw "Os motivos Acompanhamento Puérpera e Acompanhamento Gestante não podem ser selecionados em visitas a pacientes do sexo Masculino.\n"+
              "Corrija o motivo da visita ou o sexo do paciente no cadastro de indivíduos.";
            }
          }
        }

        if (isInvalid($scope.visita.desfecho)) {
          throw "Informe o Desfecho";
        }
        
        if (isValid($scope.domicilio.individuos) && $scope.domicilio.individuos.length > 0) {
          for (var i = 0; i < $scope.domicilio.individuos.length; i++) {
            var individuo = $scope.domicilio.individuos[i];
            //  if(isNaN(individuo.peso)){
            if (individuo.peso) {
              var peso = individuo.peso;
              if (peso > 0) {
                if (peso < 0.500 || peso > 500) {
                  throw "Por favor verifique o peso, do indivíduo, " + individuo.nome + ", está entre: \"0,500\" e \"500\" KG";
                }
              }
            }

            if (individuo.altura) {
              individuo.altura = parseFloat(individuo.altura)
              if (individuo.altura && individuo.altura > 0) {
                if (individuo.altura < 20 || individuo.altura > 250) {
                  throw "Por favor verifique se a altura, do indivíduo, " + individuo.nome + ", está entre: 20 e 250 CM";
                }
              }
            }

            if ($scope.visita.desfecho === 3 || $scope.visita.desfecho === 2) {
              if (individuo.peso && (individuo.pesoOriginal != individuo.peso) || individuo.altura && (individuo.alturaOriginal != individuo.altura)) {
                individuo.peso = individuo.pesoOriginal;
                individuo.altura = individuo.alturaOriginal;
                throw "O desfecho da visita foi \"Ausente\" ou \"Visita Recusada\", o peso e a altura , do indivíduo, " + individuo.nome + " , serão mantidos os originais"
              }
            }

            if ($scope.visita.codigoIndividuo === individuo.id) {

              $scope.visita.peso = individuo.peso * 1000;
              $scope.visita.altura = individuo.altura;
            }
          }
        }
      } catch (err) {
        $scope.messagePopup(err);
        return;
      }

      DB.session.transaction(function (tx) {
        if (isValid($scope.domicilio.individuos) && $scope.domicilio.individuos.length > 0) {
          for (var i = 0; i < $scope.domicilio.individuos.length; i++) {
            var individuo = $scope.domicilio.individuos[i];
            if (individuo.pesoOriginal !== individuo.peso || individuo.alturaOriginal !== individuo.altura) {
              individuo.peso = individuo.peso * 1000;
              $scope.atualizarPacienteDado(individuo, tx);
            }
          }
        }

        $scope.atualizarVisitaDomicilio(tx);
        $scope.salvarVisita(tx);
      }, function (err) {
        $scope.messagePopup(err.message);
      }, function () { //Transaction success
        $scope.continuarVoltar('Continuar registrando a visita da mesma família?').then(function (resposta) {
          if (resposta) {
            $scope.limpar();
            $state.go('cadastroVisitas.tabVisita');
          } else {
            $state.go('visitas');
          }
        });
      });
    };

    $scope.atualizarVisitaDomicilio = function (tx) {
      var sql = "UPDATE domicilio SET visitaNoMes = 1 WHERE id = ?";
      var param = [];
      param.push($scope.bind.idDomicilio);
      tx.executeSql(sql, param);
    };

    $scope.atualizarPacienteDado = function (individuo, tx) {
      var sql = "SELECT id from pacienteDado WHERE codigoPaciente = ?";
      var param1 = [];
      param1.push(individuo.id);
      tx.executeSql(sql, param1, function (tx, result) {
        // var pacienteDado DB.fetch(result);
        individuo.idPacienteDado = result;
      });

      if (isValid(individuo.idPacienteDado)) {
        var sql = "UPDATE pacienteDado SET peso = ?, altura = ?, dataColeta = ?, codigoUsuario = ? WHERE id = ?";
        var param = [];
        param.push(individuo.peso);
        param.push(individuo.altura);
        param.push(new Date().getTime()  / 1000);
        param.push($scope.usuario.id);
        param.push(individuo.idPacienteDado);
        tx.executeSql(sql, param);
      } else {
        var sql = "INSERT INTO pacienteDado (peso, altura, dataColeta, codigoPaciente, codigoUsuario) VALUES (?,?,?,?,?)";
        var param = [];
        param.push(individuo.peso);
        param.push(individuo.altura);
        param.push(new Date().getTime()  / 1000);
        param.push(individuo.id);
        param.push($scope.usuario.id);
        tx.executeSql(sql, param);
      }
      if (individuo.peso && individuo.peso != 0) {
        individuo.peso = individuo.peso / 1000;
      }
    };

    $scope.salvarVisita = function (tx) {
      var binding = [];
      var registroVisita = "INSERT INTO visitaDomiciliar " +
        " (codigoUsuario, codigoDomicilio, dataVisita, compartilhada, codigoPaciente," +
        " desfecho, motivoAtualizacao, motivoVisitaPeriodica, motivoBaConsulta, motivoBaExame," +
        " motivoBaVacina, motivoBaCondicionalidadesBolsaFamilia, motivoAcGestante, motivoAcPuerpera," +
        " motivoAcRecemNascido, motivoAcCrianca, motivoAcPessoaDesnutrida, motivoAcPessoaDeficiente," +
        " motivoAcPessoaHipertensa, motivoAcPessoaDiabetes, motivoAcPessoaAsmatica, motivoAcPessoaEnfisema," +
        " motivoAcPessoaCancer, motivoAcPessoaDoencaCronica, motivoAcPessoaHanseniase, motivoAcPessoaTuberculose," +
        " motivoAcAcamado, motivoAcVulnerabilidadeSocial, motivoAcCondicionalidadesBolsaFamilia, motivoAcSaudeMental," +
        " motivoAcUsuarioAlcool, motivoAcUsuarioDroga, motivoEgressoInternacao, motivoControleAmbientesVetores," +
        " motivoCampanhaSaude, motivoPrevencao, motivoOutros, latitude, longitude, peso, altura, uuidTablet, " +
        " motivoSintomaticosRespiratorios, motivoTabagista, motivoAcaoEducativa, motivoImovelComFoco, motivoAcaoMecanica, motivoTratamentoFocal)" +
        " VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?, ?, ?, ?, ?,?,?,?,?,?); SELECT last_insert_rowid() FROM pesquisaVisita";

      binding.push($scope.usuario.id);
      binding.push($scope.bind.idDomicilio);
      binding.push(new Date().getTime() / 1000);
      binding.push($scope.visita.compartilhada);
      binding.push($scope.visita.codigoIndividuo);
      binding.push($scope.visita.desfecho);
      binding.push($scope.visita.motivoAtualizacao);
      binding.push($scope.visita.motivoVisitaPeriodica);
      binding.push($scope.visita.motivoBaConsulta);
      binding.push($scope.visita.motivoBaExame);
      binding.push($scope.visita.motivoBaVacina);
      binding.push($scope.visita.motivoBaCondicionalidadesBolsaFamilia);
      binding.push($scope.visita.motivoAcGestante);
      binding.push($scope.visita.motivoAcPuerpera);
      binding.push($scope.visita.motivoAcRecemNascido);
      binding.push($scope.visita.motivoAcCrianca);
      binding.push($scope.visita.motivoAcPessoaDesnutrida);
      binding.push($scope.visita.motivoAcPessoaDeficiente);
      binding.push($scope.visita.motivoAcPessoaHipertensa);
      binding.push($scope.visita.motivoAcPessoaDiabetes);
      binding.push($scope.visita.motivoAcPessoaAsmatica);
      binding.push($scope.visita.motivoAcPessoaEnfisema);
      binding.push($scope.visita.motivoAcPessoaCancer);
      binding.push($scope.visita.motivoAcPessoaDoencaCronica);
      binding.push($scope.visita.motivoAcPessoaHanseniase);
      binding.push($scope.visita.motivoAcPessoaTuberculose);
      binding.push($scope.visita.motivoAcAcamado);
      binding.push($scope.visita.motivoAcVulnerabilidadeSocial);
      binding.push($scope.visita.motivoAcCondicionalidadesBolsaFamilia);
      binding.push($scope.visita.motivoAcSaudeMental);
      binding.push($scope.visita.motivoAcUsuarioAlcool);
      binding.push($scope.visita.motivoAcUsuarioDroga);
      binding.push($scope.visita.motivoEgressoInternacao);
      binding.push($scope.visita.motivoControleAmbientesVetores);
      binding.push($scope.visita.motivoCampanhaSaude);
      binding.push($scope.visita.motivoPrevencao);
      binding.push($scope.visita.motivoOutros);
      binding.push($scope.visita.latitude);
      binding.push($scope.visita.longitude);
      binding.push($scope.visita.peso);
      binding.push($scope.visita.altura);
      binding.push($cordovaDevice.getUUID() + new Date().getTime());

      binding.push($scope.visita.motivoSintomaticosRespiratorios);
      binding.push($scope.visita.motivoTabagista);
      binding.push($scope.visita.motivoAcaoEducativa);
      binding.push($scope.visita.motivoImovelComFoco);
      binding.push($scope.visita.motivoAcaoMecanica);
      binding.push($scope.visita.motivoTratamentoFocal);

      tx.executeSql(registroVisita, binding, function (tx, result) {
        $scope.salvarPesquisa(tx, result.insertId);
      });
    };

    $scope.salvarPesquisa = function (tx, codigoVisita) {
      if (isValid($scope.bind.codigoPesquisa)) {
        for (var i = 0; i < $scope.bind.perguntas.length; i++) {
          if (isValid($scope.bind.perguntas[i].checked)) {
            var binding = [];
            var registroVisita = "INSERT INTO pesquisaVisita " +
              " (codigoResposta, codigoVisita, codigoPesquisaPergunta, codigoUsuario)" +
              " VALUES (?,?,?,?); ";

            binding.push($scope.bind.perguntas[i].checked);
            binding.push(codigoVisita);
            binding.push($scope.bind.perguntas[i].codigoPesquisaPergunta);
            binding.push($scope.usuario.id);

            tx.executeSql(registroVisita, binding);
          }
        }
      }
    };

    $scope.continuarVoltar = function (mensagem) {
      var deferred = $q.defer();
      //https://github.com/driftyco/ionic/blob/master/js/angular/service/platform.js  TO VIEW PRIORITY LIST
      var deregisterBackEvent = $ionicPlatform.registerBackButtonAction(function () {}, 501);
      $ionicLoading.hide();
      var alertPopup = $ionicPopup.confirm({
        title: 'Registro Salvo com Sucesso!',
        template: mensagem,
        buttons: [{
          text: 'Voltar'
        }, {
          text: '<b>Continuar</b>',
          type: 'button-positive',
          onTap: function (e) {
            return true;
          }
        }]
      });
      alertPopup.then(function (resposta) {
        deregisterBackEvent();
        return deferred.resolve(resposta);
      });

      return deferred.promise;
    };

    $scope.pesquisarGps = function () {
      $scope.bind.gpsMsg = 'Procurando Localização...';
      $scope.bind.iconeLocalizacao = 'icon ion-looping';
      $scope.bind.gpsParado = false;
      var posOptions = {
        timeout: 60000,
        enableHighAccuracy: true
      };
      $cordovaGeolocation.getCurrentPosition(posOptions)
        .then(function (position) {
          $scope.bind.gpsParado = false;
          $scope.visita.latitude = position.coords.latitude;
          $scope.visita.longitude = position.coords.longitude;
          $scope.bind.gpsMsg = 'Localização encontrada';
          $scope.bind.iconeLocalizacao = 'icon ion-earth';
          console.log('LATITUDE: ' + $scope.visita.latitude);
          console.log('LONGITUDE: ' + $scope.visita.longitude);
        }, function (err) {
          $scope.bind.iconeLocalizacao = 'icon ion-eye-disabled';
          $scope.bind.gpsMsg = 'Não foi possível determinar a localização, verifique se o GPS está ativo.';
          console.log('CELK: ' + err.message);
          $scope.bind.gpsParado = true;
        });
    };

    $scope.exibePerguntas = function () {
      var sql = " SELECT count(*) AS count FROM perguntaResposta t1, pesquisaPergunta t2 " +
        " left join perguntaPesquisa t3 on t2.codigoPergunta = t3.id" +
        " left join pesquisa t4 on t2.codigoPesquisa = t4.id" +
        " where t1.codigoPergunta = t2.codigoPergunta" +
        " and t4.status = 0" +
        " and strftime('%s','now', 'localtime') between t4.inicio and t4.fim";

      DB.query(sql).then(function (result) {
        result = DB.fetch(result);
        if (result.count > 0) {
          $scope.bind.exibePerguntas = true;
        }
      });
    };

    if (temporario) {
      $scope.bind = temporario.bind;
      $scope.visita = temporario.visita;
      $scope.domicilio = temporario.domicilio;
      $scope.carregarIndividuos();
    } else {
      $scope.carregarDomicilio();
      $scope.pesquisarGps();
      $scope.exibePerguntas();
    }
  }
]);

controllers.controller('tabVisitaCtrl', ['$scope', '$ionicModal', '$state', 'DB',
  function ($scope, $ionicModal, $state, DB) {

    //<editor-fold defaultstate="collapsed" desc="Modal Individuo">
    $ionicModal.fromTemplateUrl('templates/modals/individuoFamilia.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function (modal) {
      $scope.modalIndividuo = modal;
    });

    var marcarAcompanhamento = function (item) {
      var monthDiff = function monthDiff(d1, d2) {
        var months;
        months = (d2.getFullYear() - d1.getFullYear()) * 12;
        months -= d1.getMonth() + 1;
        months += d2.getMonth();
        return months <= 0 ? 0 : months;
      }

      if (!$scope.disabledField) {
        var sql = "SELECT estaGestante, deficienciaAuditiva, deficienciaVisual, deficienciaFisica, deficienciaIntelectual, deficienciaOutra, temHipertensao, temDiabetes, respiratoriaAsma, respiratoriaEfisema, temTeveCancer, temHanseniase, temTuberculose, estaAcamado, estaDomiciliado, possuiSofrimentoPsiquicoGrave, fumante, dependenteAlcool, dependenteDroga, doencaRespiratoria, fumante FROM pacienteEsus WHERE codigoPaciente = ?"
        DB.query(sql, [item.id]).then(function (result) {
          var pacienteEsus = DB.fetch(result);
          if (pacienteEsus) {
            motivosAc.motivoAcGestante = pacienteEsus.estaGestante;
            var strDate = item.dataNascimento;
            var dateParts = strDate.split("/");
            var date = new Date(dateParts[2], (dateParts[0] - 1), dateParts[1]);

            $scope.$parent.visita.motivoAcGestante = pacienteEsus.estaGestante;
            $scope.$parent.visita.motivoAcCrianca = (monthDiff(date, new Date()) <= window.localStorage.idadeAcompanhamento) ? 1 : 0;
            $scope.$parent.visita.motivoAcPessoaDeficiente = (pacienteEsus.deficienciaAuditiva == 1 || pacienteEsus.deficienciaVisual == 1 || pacienteEsus.deficienciaFisica == 1 || pacienteEsus.deficienciaIntelectual == 1 || pacienteEsus.deficienciaOutra == 1) ? 1 : 0;
            $scope.$parent.visita.motivoAcPessoaHipertensa = pacienteEsus.temHipertensao;
            $scope.$parent.visita.motivoAcPessoaDiabetes = pacienteEsus.temDiabetes;
            $scope.$parent.visita.motivoAcPessoaAsmatica = pacienteEsus.respiratoriaAsma;
            $scope.$parent.visita.motivoAcPessoaEnfisema = pacienteEsus.respiratoriaEfisema;
            $scope.$parent.visita.motivoAcPessoaCancer = pacienteEsus.temTeveCancer;
            $scope.$parent.visita.motivoAcPessoaHanseniase = pacienteEsus.temHanseniase;
            $scope.$parent.visita.motivoAcPessoaTuberculose = pacienteEsus.temTuberculose;
            $scope.$parent.visita.motivoAcAcamado = (pacienteEsus.estaAcamado == 1 || pacienteEsus.estaDomiciliado == 1) ? 1 : 0;
            $scope.$parent.visita.motivoAcSaudeMental = pacienteEsus.possuiSofrimentoPsiquicoGrave;
            $scope.$parent.visita.motivoAcUsuarioAlcool = pacienteEsus.dependenteAlcool;
            $scope.$parent.visita.motivoAcUsuarioDroga = pacienteEsus.dependenteDroga;
            $scope.$parent.visita.motivoSintomaticosRespiratorios = pacienteEsus.doencaRespiratoria;
            $scope.$parent.visita.motivoTabagista = pacienteEsus.fumante;
          }
        }, $scope.err);
      }
    };
    $scope.individuoSelecionado = function (item) {
      $scope.$parent.visita.nomeIndividuo = item.nome;
      $scope.$parent.visita.codigoIndividuo = item.id;
      $scope.fecharIndividuo();
      if (isInvalid(item.cnsId)) {
        $scope.showConfirmation('O Indivíduo não possui CNS cadastrado. Deseja editar?')
          .then(function (resp) {
            if (resp) {
              $scope.salvarTemporario();
              $state.go('cadastroIndividuos.tabIdentificacao', {
                idIndividuo: item.id
              });
            }
          });
      }
      marcarAcompanhamento(item);
    };


    $scope.limparIndividuo = function () {
      $scope.$parent.visita.nomeIndividuo = '';
      $scope.$parent.visita.codigoIndividuo = '';
      $scope.$parent.visita.dataNascimentoIndividuo = '';
    };

    $scope.fecharIndividuo = function () {
      $scope.modalIndividuo.hide();
    };

    $scope.selecionarIndividuo = function () {
      $scope.modalIndividuo.show();
    };
    //</editor-fold>

    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function () {
      if ($scope.modalIndividuo) {
        $scope.modalIndividuo.remove();
      }
    });
  }
]);

controllers.controller('tabMotivoCtrl', ['$scope',
  function ($scope) {}
]);

controllers.controller('tabDesfechoCtrl', ['$scope',
  function ($scope) {}
]);

controllers.controller('tabPesquisaCtrl', ['$scope', 'DB',
  function ($scope, DB) {
    $scope.carregarPerguntas = function () {
      if (isInvalid($scope.bind.codigoPesquisa)) {
        $scope.bind.perguntas = [];
        var sql = " SELECT t2.id AS codigoPesquisaPergunta, t2.codigoPesquisa, t2.codigoPergunta, t1.id AS codigoResposta, t3.descricao AS pergunta, t1.descricao AS resposta FROM perguntaResposta t1, pesquisaPergunta t2 " +
          " left join perguntaPesquisa t3 on t2.codigoPergunta = t3.id" +
          " left join pesquisa t4 on t2.codigoPesquisa = t4.id" +
          " where t1.codigoPergunta = t2.codigoPergunta" +
          " and t4.status = 0" +
          " and strftime('%s','now', 'localtime') between t4.inicio and t4.fim" +
          " order by t2.codigoPesquisa, t2.codigoPergunta, t1.id";

        DB.query(sql).then(function (result) {
          result = DB.fetchAll(result);
          if (result.length > 0) {
            $scope.bind.codigoPesquisa = result[0].codigoPesquisa;
            var pergunta;
            for (var i = 0; i < result.length; i++) {
              if (result[i].codigoPesquisa == $scope.bind.codigoPesquisa) {
                if (isInvalid(pergunta) || result[i].codigoPergunta != pergunta.codigo) {
                  pergunta = {
                    respostas: []
                  };
                  pergunta.codigo = result[i].codigoPergunta;
                  pergunta.descricao = result[i].pergunta;
                  pergunta.codigoPesquisaPergunta = result[i].codigoPesquisaPergunta;
                  $scope.bind.perguntas.push(pergunta);
                }
                var resposta = {};
                resposta.codigo = result[i].codigoResposta;
                resposta.descricao = result[i].resposta;
                pergunta.respostas.push(resposta);
              } else {
                break;
              }
            }
          }
        });
      }
    };

    $scope.uncheck = function (event, pergunta, resposta) {
      if (pergunta.checkedOld == event.target.value) {
        pergunta.checkedOld = null;
        pergunta.checked = null;
      } else {
        pergunta.checkedOld = event.target.value;
      }
    };

    $scope.carregarPerguntas();
  }
]);

controllers.controller('tabIndividuosCtrl', ['$scope', '$state',
  function ($scope, $state) {

    $scope.editarVacinas = function (index) {
      var item = $scope.$parent.domicilio.individuos[index];

      $scope.salvarTemporario();
      $state.go('controleVacinas', {
        idIndividuo: item.id,
        idDomicilio: $scope.bind.idDomicilio
      });
    };

    $scope.editarAgendamentos = function (index) {
      var item = $scope.$parent.domicilio.individuos[index];

      $scope.salvarTemporario();
      $state.go('agendasPendentes', {
        idIndividuo: item.id,
        idDomicilio: $scope.bind.idDomicilio
      });
    };

    $scope.definirAvatar = function (item) {
      if (item.sexo == "F") {
        return "imagens/girl_96x96.png";
      } else {
        return "imagens/person_96x96.png";
      }
    };
  }
]);