controllers.controller('menuCtrl', ['$rootScope', '$scope', '$state', '$ionicHistory', 'DB', '$ionicLoading', '$ionicPopup', '$q', '$http', '$cordovaFile', '$cordovaFileOpener2', '$cordovaAppVersion', 'storageService', 'messageService', 'updateService','googleAnalyticsService', 'sincronizacaoService', 'validacaoService', 'dataService',
    function ($rootScope, $scope, $state, $ionicHistory, DB, $ionicLoading, $ionicPopup, $q, $http, $cordovaFile, $cordovaFileOpener2, $cordovaAppVersion, storageService, messageService, updateService, googleAnalyticsService, sincronizacaoService, validacaoService,dataService) {
        $ionicLoading.show({
            template: 'Carregando...'
        });

        $scope.verBotaoSair = true;

        storageService.removeItem("microarea");
        storageService.removeItem("tempDomicilio");
        storageService.removeItem("tempVisita");
        $scope.usuario = JSON.parse(storageService.getItem('usuarioLogado'));
        $ionicHistory.clearHistory();
        $scope.bind = {};
        $scope.isReady = false;

        $scope.diassinc = storageService.getItem('diassinc');
        $scope.datasinc = storageService.getItem('datasinc');
        $scope.desabilita = storageService.getItem('desabilita');
        $scope.desabilitaMensagem = storageService.getItem('desabilitaMensagem');
        $scope.desabilitaSincronizacao = storageService.getItem('desabilitaSincronizacao');

        //Solicitar Processamento manual
        $scope.solicitado = !!storageService.getItem('solicitado');
        $scope.loteErro = !!storageService.getItem('loteErro');

        if(storageService.getItem("intervalIds")){
            var intervalIds = JSON.parse(storageService.getItem("intervalIds"));
            console.log(intervalIds);
            if(intervalIds.length >0){
                intervalIds.forEach(function(element) {
                    console.log(element);
                    console.log(clearInterval(element));
                });
            }
            storageService.removeItem("intervalIds");
        }
        

        $scope.actSolicitarCorrecao = function () {
            var mensagem = {};
            $scope.showConfirmation("Ao Solicitar um Processamento Manual o aplicativo será bloqueado até que o processamento manual seja efetuada. Solicitar assim mesmo?").then(function (resposta) {
                if (resposta) {
                    mensagem.url = storageService.getItem('dominio');
                    var usuarioLogado = storageService.getItem('usuarioLogado');
                    usuarioLogado = JSON.parse(usuarioLogado);
                    mensagem.usuario = "(" + usuarioLogado.codigoSistema + ") - " + usuarioLogado.nome;
                    mensagem.microarea = storageService.getItem('microarea1');
                    mensagem.area = "(" + storageService.getItem('codigoarea') + ") - " + storageService.getItem('descricaoarea');
                    mensagem.versaoTablet = storageService.getItem('versaoLocal');
                    mensagem.lote = storageService.getItem('loteErro');
                    mensagem.erro = '';

                    if (storageService.getItem('ultimoErro')) {
                        var _local = JSON.parse(storageService.getItem('ultimoErro'));
                        _local.forEach(function (element) {
                            mensagem.erro = mensagem.erro + element + '<br /> ';
                            console.log(mensagem.erro);
                        });
                    }

                    var _postSendEmail = function () {
                        storageService.setItem('desabilita', true);
                        dataService.data.desabilita = true;
                        storageService.setItem('desabilitaMensagem', 'Foi solicitado um processamento manual, por favor, verificar o retorno na tela de Sincronização');
                        storageService.setItem('solicitado', true);
                        $scope.solicitado = true;
                        storageService.removeItem("ultimoErro");
                        $state.reload();
                    };

                    if (!validacaoService.isDev()) {
                        $http.post(dataService.data.url + G_versao + '/' + G_id + "/solicitar-correcao", mensagem)
                            .success(function (data) {
                                _postSendEmail();
                            })
                            .error(function () {
                                messageService.mostrarAlerta(messageService.mensagensErro.COMUNICACAO_SERVIDOR);
                            });
                    } else {
                        _postSendEmail();
                    }
                }
            });
        };

        if ($scope.datasinc == 1) {
            $ionicPopup.alert({
                title: 'Atenção',
                template: 'O tempo de sincronização está expirando, este dispositivo deve ser sincronizado ou os serviços serão bloqueados.'
            });
        }

        $scope.alertaBloqueio = function() {
        if (!$scope.desabilitaSincronizacao) {
            if(!$scope.desabilitaMensagem){
                messageService.mostrarAlerta( 'Esta funcionalidade está bloqueada, por favor sincronize o seu dispositivo.');
            }else{
                messageService.mostrarAlerta($scope.desabilitaMensagem);
            }
        }else {
                updateService.verificarAtualizacao($scope);
            }
        }

        $scope.microAreaCarregada = function (msg) {
            if (msg) {
                $scope.alerta = msg;
            }
            $scope.verificarIncosistencias();
        };

        $scope.verificarIncosistencias = function () {
            DB.query("SELECT SUM(c) AS count FROM (SELECT COUNT(*) AS c FROM erroDomicilio UNION ALL SELECT COUNT(*) AS c FROM erroPaciente)", []).then(function (result) {
                var retorno = DB.fetch(result);
                $scope.bind.inconsistencias = retorno.count;
                if (retorno.count > 0) {
                    $scope.verPendencias = true;
                }
                $ionicLoading.hide();
                updateService.verificarAtualizacao($scope);
            });
        };

     $scope.showConfirmation = function (mensagem) {
            var deferred = $q.defer();
            var alertPopup = $ionicPopup.confirm({
                title: 'Atenção!',
                template: mensagem,
                buttons: [{
                        text: 'Não'
                    },
                    {
                        text: '<b>Sim</b>',
                        type: 'button-positive',
                        onTap: function (e) {
                            return true;
                        }
                    }
                ]
            });
            alertPopup.then(function (resposta) {
                return deferred.resolve(resposta);
            });

            return deferred.promise;
        };

        $scope.acaoPendencias = function () {
            $state.go('inconsistencias');
        };

        $scope.goDomicilios = function () {
            $state.go('domicilios');
        };

        $scope.goIndividuos = function () {
            $state.go('individuos');
        };

        $scope.goSincronizacao = function () {
            storageService.removeItem('ressincronizar');
            $state.go('sincronizacaoInicial');
        };

        $scope.goVisitas = function () {
            $state.go('visitas');
        };

        $scope.acaoSair = function () {
            messageService.mostrarConfirmacao('Deseja realmente sair do seu usuário?').then(function (resp) {
                if (resp) {
                    storageService.removeItem('usuarioLogado');
                    $state.go('login');

                }
            });
        };

        DB.ready(function () {
            DB.session.transaction(function (tx) {

                tx.executeSql("SELECT codigoProfissional FROM usuarios where id = ?", [$scope.usuario.id], function (tx, result) {
                    var usuario = DB.fetch(result);
                    if (isValid(usuario.codigoProfissional)) {

                        tx.executeSql("SELECT ma.id, ma.microArea AS microArea, eq.descricao AS area, eq.codigoSistema AS codigoArea FROM equipeProfissional AS ep " +
                            " LEFT JOIN microArea AS ma ON ep.codigoMicroArea = ma.id " +
                            " LEFT JOIN equipe AS eq ON ep.codigoEquipe = eq.id " +
                            " WHERE ep.status = 0 " +
                            " AND ep.codigoProfissional = ?", [usuario.codigoProfissional],
                            function (tx, result) {
                                var equipeProfissional = DB.fetchAll(result);
                                if (equipeProfissional.length > 1) {
                                    $scope.microAreaCarregada('O Profissional está vinculado a mais de uma equipe');
                                } else if (equipeProfissional.length === 0) {
                                    $scope.microAreaCarregada('O Profissional não está vinculado a uma equipe');
                                } else {
                                    if (isValid(equipeProfissional[0].microArea)) {
                                        $scope.area = equipeProfissional[0].area;
                                        $scope.microArea = equipeProfissional[0].microArea;
                                        $scope.$apply();

                                        storageService.setItem("microarea", equipeProfissional[0].id);
                                        storageService.setItem("microarea1", equipeProfissional[0].microArea);
                                        storageService.setItem("codigoarea", equipeProfissional[0].codigoArea);
                                        storageService.setItem("descricaoarea", equipeProfissional[0].area);
                                        $scope.microAreaCarregada();
                                    } else {
                                        $scope.microAreaCarregada('O Profissional não está vinculado a uma microárea');
                                    }
                                }
                            });
                    } else {
                        $scope.microAreaCarregada('Não existe um profissional relacionado com o usuário autenticado');
                    }
                });
            }, function (err) {
                $scope.microAreaCarregada(err.message);
            });
        });

    }
]);