controllers.controller('sincronizacaoInicialCtrl', ['$rootScope', '$q', '$scope', '$state', '$ionicPopup', '$http', 'DB', 'FS', '$ionicViewService', 'SERVER', '$resource', 'sincronizacaoService', 'storageService', 'dataService', 'messageService', 'validacaoService', 'messageService',
    function ($rootScope, $q, $scope, $state, $ionicPopup, $http, DB, FS, $ionicViewService, SERVER, $resource, sincronizacaoService, storageService, dataService, messageService, validacaoService, messageService) {

        dataService.clearData();
        $scope.data = dataService.data;
        $http.get('versao.json').success(function (data) {
            $scope.versao = data.versaoAtual.replace(/(\r\n|\n|\r)/gm, "");
        });

        $scope.sincronizacaoFinalizada = storageService.getItem("sincronizacaoFinalizada");
        $scope.sincronizacaoInicial = storageService.getItem("sincronizacaoInicial");
        $scope.usuarioLogado = JSON.parse(storageService.getItem('usuarioLogado'));
        $scope.loteErro = storageService.getItem('loteErro');
        $scope.solicitado = storageService.getItem('solicitado');
        $scope.ultimaConsulta = function () {
            if(parseInt(storageService.getItem("ultimaConsulta")) > new Date().getTime() - 1 * 60000 * 60 * 24){
                return true;              
            }
        };
        sincronizacaoService.setParentScope($scope);
        dataService.data.processando = false;
        storageService.removeItem("confirmandoLote");
        // Tratamento para guardar em uma lista 1 ou mais setInterval, para serem limpos ao trocar de tela
        if(!storageService.getItem("intervalIds") || storageService.getItem("intervalIds" === "")) {
            storageService.setItem("intervalIds", JSON.stringify([]));
        }
        var intervalIds = JSON.parse(storageService.getItem("intervalIds"));
        var intervalHandle = setInterval (
            function () {
                if ((!$scope.data.processando && $scope.data.desabilita)) {
                    sincronizacaoService.chamaRespostas();
                }
            }, 30000);
        intervalIds.push(intervalHandle);
        storageService.setItem("intervalIds", JSON.stringify(intervalIds));

        var getParams = function () {
            SERVER.get('diassincronizacao').then(function (data) {
                calcSinc(data);
            });
            SERVER.get('idadeAcompanhamento').then(function (data) {
                storageService.setItem('idadeAcompanhamento', data);
            });

            SERVER.get('parametro/UNIDADE_SAUDE/obrigaInformarCondicoesMoradiaCadastroDomiciliarTerritorial').then(function (data) {
                storageService.setItem('obrigaInformarCondicoesMoradiaCadastroDomiciliarTerritorial', data);
            });

        }

        if ($scope.sincronizacaoFinalizada) { // HACK:
            if ($scope.usuarioLogado && !isNaN($scope.usuarioLogado.id) && $scope.usuarioLogado.nivel !== 'N') {
                dataService.data.usuarioComPermissao = false;
                dataService.data.nova = true;
            }
            dataService.data.sincronizar = true;
        } else {
            $ionicViewService.clearHistory();
            if ($scope.sincronizacaoInicial) {
                dataService.data.nova = true;
                dataService.data.continuar = true;
            } else {
                dataService.data.sincronizar = true;
            }
        }


        if (storageService.getItem('isSync')) {
            storageService.removeItem('isSync')
            dataService.data.sincronizar = false;
            dataService.data.nova = false;
            storageService.setItem("sincronizacaoInicial", true);
            dataService.data.log.unshift('Iniciando processo de sincronização...');

            getParams();

            DB.deleteVersionTriggers().then(function () {
                ressincronizarRecriar();
            });
        }

        $scope.actSincronizar = function () {
            dataService.data.sincronizar = false;
            dataService.data.nova = false;
            storageService.removeItem('loteErro');
            storageService.setItem("sincronizacaoInicial", true);

            $scope.iniciarSincronizacao();
        };

        $scope.actAvancar = function (voltar) {
            if (storageService.getItem('usuarioLogado') && $scope.usuarioLogado && !isNaN($scope.usuarioLogado.id)) {
                $state.go('menu');
            } else if (voltar) {
                $ionicViewService.clearHistory();
                if ($scope.sincronizacaoInicial) {
                    dataService.data.nova = true;
                    dataService.data.continuar = true;
                    delete dataService.data.voltar;
                    ataService.data.erros = [];
                } else {
                    dataService.data.sincronizar = true;
                };
            } else {
                $state.go('login');
            }
            dataService.data.desabilita = false;
            storageService.removeItem("desabilita");
        };

        $scope.actContinuar = function () {
            storageService.initLocalStorage();
            dataService.data.nova = false;
            dataService.data.continuar = false;
            dataService.data.log = [];

            $scope.iniciarSincronizacao();
        };

        $scope.actNova = function () {
            storageService.initLocalStorage();
            $scope.showConfirmation('Os dados sincronizados até o momento serão perdidos, e a sincronização começará do início. Deseja continuar?')
                .then(function (resposta) {
                    if (resposta) {
                        $scope.novaSincronizacao();
                    }
                });
        };

        $scope.actChamaRespostas = function () {
            if ($scope.loteErro) {
                DB.query("DELETE FROM erroDomicilio;", []).then(function () {
                    DB.query("DELETE FROM erroPaciente;", []).then(function () {
                        sincronizacaoService.chamaRespostas();
                    });
                });
            } else {
                sincronizacaoService.chamaRespostas();
            }
        };
        $scope.actCancelarConsultaLote = function (){
            DB.query("DELETE FROM erroDomicilio;", []).then(function () {
                DB.query("DELETE FROM erroPaciente;", []).then(function () {
                    dataService.data.sincronizar = false;
                    dataService.data.avancar = true;
                    /// Controla para que o recurso de receber reposta do backend rode um por vez.
                    dataService.data.processando = false;
                    dataService.data.desabilita = false;
                    storageService.removeItem("confirmandoLote");
                    storageService.removeItem('loteErro');
                    storageService.removeItem("ultimaConsulta");
                });
            });
        };

        $scope.showConfirmation = function (mensagem) {
            var deferred = $q.defer();
            var alertPopup = $ionicPopup.confirm({
                title: 'Atenção!',
                template: mensagem,
                buttons: [{
                    text: 'Não'
                }, {
                    text: '<b>Sim</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        return true;
                    }
                }]
            });
            alertPopup.then(function (resposta) {
                return deferred.resolve(resposta);
            });

            return deferred.promise;
        };

        $scope.novaSincronizacao = function () {
            dataService.data.nova = false;
            dataService.data.continuar = false;
            dataService.data.sincronizar = false;
            dataService.data.log = [];

            dataService.data.log.unshift('Iniciando processo de sincronização...');
            getParams();
            DB.delete();

            storageService.removeItem("usuarioLogado");
            storageService.removeItem("sincronizacaoInicial");
            storageService.removeItem("sincronizacaoFinalizada");
            $ionicViewService.clearHistory();

            dataService.data.log.unshift('Recriando banco...');
            DB.init();

            storageService.setItem("sincronizacaoInicial", true);
            DB.ready(function () {
                $scope.iniciarSincronizacao();
            });
        };

        $scope.addProp = function (value) {
            //Remove | do valor e adiciona um | no final do campo
            return invalidToEmpty(value).toString().split('|').join('') + '|';
        };

        $scope.deletarRegistrosInconsistentes = function () {
            var deferred = $q.defer();

            DB.query("DELETE FROM erroDomicilio;", []).then(function () {
                DB.query("DELETE FROM erroPaciente;", []).then(function () {
                    return deferred.resolve();
                });
            });

            return deferred.promise;
        };


        $scope.enviarRecursos = function () {

            delete dataService.data.voltar;
            dataService.data.erros = [];

            $scope.deletarRegistrosInconsistentes().then(function () {
                //Abrir lote
                $scope.abrirLote().then(function (data) {
                    if (!data.data) {
                        dataService.data.log.unshift('LOTE JÁ EXISTE, AGUARDANDO O RETORNO.');
                        dataService.data.desabilita = true;
                        storageService.setItem("desabilita", true);
                        sincronizacaoService.chamaRespostas();
                        return;
                    }
                    $scope.enviarEndereco().then(function () {
                        dataService.data.log.unshift('ENDERECO FINALIZADO');
                        $scope.enviarDomicilio().then(function () {
                            dataService.data.log.unshift('DOMICILIO FINALIZADO');
                            $scope.enviarDomicilioEsus().then(function () {
                                dataService.data.log.unshift('DOMICILIO ESUS FINALIZADO');
                                $scope.enviarResponsaveis().then(function () {
                                    dataService.data.log.unshift('RESPONSAVEIS ENVIADOS');
                                    $scope.enviarPacientes().then(function () {
                                        dataService.data.log.unshift('PACIENTES ENVIADOS');
                                        $scope.enviarPacienteEsus().then(function () {
                                            dataService.data.log.unshift('PACIENTES ESUS ENVIADOS');
                                            $scope.enviarCns().then(function () {
                                                dataService.data.log.unshift('CNS ENVIADOS');
                                                $scope.enviarDocumentos().then(function () {
                                                    dataService.data.log.unshift('DOCUMENTOS ENVIADOS');
                                                    $scope.enviarPacienteDado().then(function () {
                                                        dataService.data.log.unshift('PACIENTES DADO ENVIADOS');
                                                        $scope.enviarVisitas().then(function () {
                                                            dataService.data.log.unshift('VISITAS ENVIADAS');
                                                            $scope.enviarNotificacoesAgendamentos().then(function () {
                                                                dataService.data.log.unshift('NOTIFICACOES DE AGENDAMENTOS ENVIADAS');
                                                                $scope.enviarRegistroVacina().then(function () {
                                                                    dataService.data.log.unshift('REGISTROS DE VACINAS ENVIADAS');
                                                                    $scope.enviarImagensVacina().then(function () {
                                                                        dataService.data.log.unshift('IMAGENS DE VACINAS ENVIADAS');
                                                                        $scope.enviarPesquisas().then(function () {
                                                                            dataService.data.log.unshift('PESQUISAS ENVIADAS');
                                                                            $scope.fecharLote().then(function (data) {
                                                                                storageService.setItem("host", data.data.host);
                                                                                // FCMPlugin.unsubscribeFromTopic(storageService.getItem("codigoProfissional")+storageService.getItem("host"));
                                                                                // FCMPlugin.subscribeToTopic(storageService.getItem("codigoProfissional")+storageService.getItem("host"));
                                                                                // FCMPlugin.onNotification(function(data){
                                                                                //     $rootScope.$broadcast("notification", data);
                                                                                // });

                                                                                dataService.data.log.unshift('LOTE ENVIADO PARA FILA DE PROCESSAMENTO... AGUARDE ...');

                                                                                dataService.data.desabilita = true;
                                                                                storageService.setItem("desabilita", true);

                                                                            }, function (data, status, header) {
                                                                                sincronizacaoService.problemaConexao();
                                                                            });
                                                                        }, function (data, status, header) {
                                                                            sincronizacaoService.problemaConexao();
                                                                        });
                                                                    }, function (data, status, header) {
                                                                        sincronizacaoService.problemaConexao();
                                                                    });
                                                                }, function (data, status, header) {
                                                                    sincronizacaoService.problemaConexao();
                                                                });
                                                            }, function (data, status, header) {
                                                                sincronizacaoService.problemaConexao();
                                                            });
                                                        }, function (data, status, header) {
                                                            sincronizacaoService.problemaConexao();
                                                        });
                                                    }, function (data, status, header) {
                                                        sincronizacaoService.problemaConexao();
                                                    });
                                                }, function (data, status, header) {
                                                    sincronizacaoService.problemaConexao();
                                                });
                                            }, function (data, status, header) {
                                                sincronizacaoService.problemaConexao();
                                            });
                                        }, function (data, status, header) {
                                            sincronizacaoService.problemaConexao();
                                        });
                                    }, function (data, status, header) {
                                        sincronizacaoService.problemaConexao();
                                    });
                                }, function (data, status, header) {
                                    sincronizacaoService.problemaConexao();
                                });
                            }, function (data, status, header) {
                                sincronizacaoService.problemaConexao();
                            });
                        }, function (data, status, header) {
                            sincronizacaoService.problemaConexao();
                        });
                    }, function (data, status, header) {
                        sincronizacaoService.problemaConexao();
                    });
                }, function (data, status, header) {
                    sincronizacaoService.problemaConexao(data);
                });

            }, function (data, status, header) {
                sincronizacaoService.problemaConexao();
            });

        };

        $scope.enviarVisitas = function () {
            var deferred = $q.defer();

            var montarVisitas = function (visita) {
                var l = '';
                l += $scope.addProp(visita.codigoSistema);
                l += $scope.addProp(visita.id);
                if (isInvalid(visita.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(visita.codigoSistemaUsuario);
                }
                l += $scope.addProp(visita.codigoSistemaDomicilio);
                l += $scope.addProp(visita.dataVisitaFormatada);
                l += $scope.addProp(visita.horaVisitaFormatada);
                l += $scope.addProp(visita.compartilhada);
                l += $scope.addProp(visita.codigoSistemaPaciente);
                l += $scope.addProp(visita.desfecho);
                l += $scope.addProp(visita.motivoAtualizacao);
                l += $scope.addProp(visita.motivoVisitaPeriodica);
                l += $scope.addProp(visita.motivoBaConsulta);
                l += $scope.addProp(visita.motivoBaExame);
                l += $scope.addProp(visita.motivoBaVacina);
                l += $scope.addProp(visita.motivoBaCondicionalidadesBolsaFamilia);
                l += $scope.addProp(visita.motivoAcGestante);
                l += $scope.addProp(visita.motivoAcPuerpera);
                l += $scope.addProp(visita.motivoAcRecemNascido);
                l += $scope.addProp(visita.motivoAcCrianca);
                l += $scope.addProp(visita.motivoAcPessoaDesnutrida);
                l += $scope.addProp(visita.motivoAcPessoaDeficiente);
                l += $scope.addProp(visita.motivoAcPessoaHipertensa);
                l += $scope.addProp(visita.motivoAcPessoaDiabetes);
                l += $scope.addProp(visita.motivoAcPessoaAsmatica);
                l += $scope.addProp(visita.motivoAcPessoaEnfisema);
                l += $scope.addProp(visita.motivoAcPessoaCancer);
                l += $scope.addProp(visita.motivoAcPessoaDoencaCronica);
                l += $scope.addProp(visita.motivoAcPessoaHanseniase);
                l += $scope.addProp(visita.motivoAcPessoaTuberculose);
                l += $scope.addProp(visita.motivoAcAcamado);
                l += $scope.addProp(visita.motivoAcVulnerabilidadeSocial);
                l += $scope.addProp(visita.motivoAcCondicionalidadesBolsaFamilia);
                l += $scope.addProp(visita.motivoAcSaudeMental);
                l += $scope.addProp(visita.motivoAcUsuarioAlcool);
                l += $scope.addProp(visita.motivoAcUsuarioDroga);
                l += $scope.addProp(visita.motivoEgressoInternacao);
                l += $scope.addProp(visita.motivoControleAmbientesVetores);
                l += $scope.addProp(visita.motivoCampanhaSaude);
                l += $scope.addProp(visita.motivoPrevencao);
                l += $scope.addProp(visita.motivoOutros);
                l += $scope.addProp(visita.dataColetaGpsFormatada);
                l += $scope.addProp(visita.horaColetaGpsFormatada);
                l += $scope.addProp(visita.latitude);
                l += $scope.addProp(visita.longitude);
                l += $scope.addProp(visita.peso);
                l += $scope.addProp(visita.altura);
                l += $scope.addProp(visita.uuidTablet);
                l += $scope.addProp(visita.uuidPaciente);
                l += $scope.addProp(visita.uuidDomicilio);

                l += $scope.addProp(visita.motivoSintomaticosRespiratorios);
                l += $scope.addProp(visita.motivoTabagista);
                l += $scope.addProp(visita.motivoAcaoEducativa);
                l += $scope.addProp(visita.motivoImovelComFoco);
                l += $scope.addProp(visita.motivoAcaoMecanica);
                l += $scope.addProp(visita.motivoTratamentoFocal);

                return l.substring(0, l.length - 1);
            };
            //VISITAS
            var sql = "SELECT v.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " p.codigoSistema AS codigoSistemaPaciente," +
                " p.uuidTablet AS uuidPaciente," +
                " dom.codigoSistema AS codigoSistemaDomicilio," +
                " dom.uuidTablet AS uuidDomicilio," +
                " strftime('%d-%m-%Y', v.dataVisita, 'unixepoch', 'localtime') AS dataVisitaFormatada," +
                " strftime('%H:%M:%S', v.dataVisita, 'unixepoch', 'localtime') AS horaVisitaFormatada," +
                " strftime('%d-%m-%Y', v.dataColetaGps, 'unixepoch', 'localtime') AS dataColetaGpsFormatada," +
                " strftime('%H:%M:%S', v.horaColetaGps, 'unixepoch', 'localtime') AS horaColetaGpsFormatada" +
                " FROM visitaDomiciliar v" +
                " LEFT JOIN usuarios AS u ON u.id = v.codigoUsuario" +
                " LEFT JOIN paciente AS p ON p.id = v.codigoPaciente" +
                " LEFT JOIN domicilio AS dom ON dom.id = v.codigoDomicilio" +
                " WHERE v.codigoSistema is null" +
                " AND u.codigoSistema is not null"

            DB.query(sql, []).then(function (result) {
                var visita = DB.fetchAll(result);
                if (visita.length > 0) {
                    var layout = '';
                    for (var i = 0; i < visita.length; i++) {
                        layout += montarVisitas(visita[i]) + '\n';
                    }
                    SERVER.post('visita_domiciliar', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarNotificacoesAgendamentos = function () {
            var deferred = $q.defer();

            var montarNotificacoes = function (agenda) {

                var l = '';

                l += $scope.addProp(agenda.codigoSistema);
                l += $scope.addProp(agenda.id);
                l += $scope.addProp(agenda.codigoSistemaUsuario);
                l += $scope.addProp(agenda.statusMobile);
                l += $scope.addProp(agenda.codigoSistemaMotivo);
                l += $scope.addProp(agenda.descricaoOutroMotivo);

                return l.substring(0, l.length - 1);
            };

            var sql = "SELECT n.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " m.codigoSistema AS codigoSistemaMotivo" +
                " FROM notificacaoAgendas n" +
                " INNER JOIN usuarios AS u ON u.id = n.codigoUsuario " +
                " LEFT JOIN motivoNaoComparecimento AS m ON m.id = n.codigoMotivo";

            DB.query(sql).then(function (result) {
                var notificacoes = DB.fetchAll(result);
                if (notificacoes.length > 0) {
                    var layout = '';
                    for (var i = 0; i < notificacoes.length; i++) {
                        layout += montarNotificacoes(notificacoes[i]) + '\n';
                    }
                    SERVER.post('NOTIFICACAO_AGENDAS', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarRegistroVacina = function () {
            var deferred = $q.defer();

            var montarRegistros = function (registro) {
                var l = '';
                l += $scope.addProp(registro.codigoSistema);
                l += $scope.addProp(registro.id);
                l += $scope.addProp(registro.codigoSistemaUsuario);
                l += $scope.addProp(registro.codigoSistemaPaciente);
                l += $scope.addProp(registro.codigoSistemaVacina);
                l += $scope.addProp(registro.dataAplicacaoFormatada);
                l += $scope.addProp(registro.lote);
                l += $scope.addProp(registro.observacao);
                l += $scope.addProp(registro.uuidPaciente);

                return l.substring(0, l.length - 1);
            };

            var sql = "SELECT r.*, " +
                " strftime('%d-%m-%Y', r.dataAplicacao, 'unixepoch') AS dataAplicacaoFormatada," +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " p.codigoSistema AS codigoSistemaPaciente," +
                " p.uuidTablet AS uuidPaciente," +
                " t.codigoSistema AS codigoSistemaVacina" +
                " FROM registroVacinas r" +
                " LEFT JOIN usuarios AS u ON u.id = r.codigoUsuario " +
                " LEFT JOIN tipoVacina AS t ON t.id = r.codigoTipoVacina " +
                " LEFT JOIN paciente AS p ON p.id = r.codigoPaciente";

            DB.query(sql).then(function (result) {
                var registros = DB.fetchAll(result);
                if (registros.length > 0) {
                    var layout = '';
                    for (var i = 0; i < registros.length; i++) {
                        layout += montarRegistros(registros[i]) + '\n';
                    }
                    SERVER.post('REGISTRO_VACINAS', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarImagensVacina = function () {
            var deferred = $q.defer();

            var montarRegistros = function (registro) {
                var l = '';
                l += $scope.addProp(registro.codigoSistema);
                l += $scope.addProp(registro.id);
                l += $scope.addProp(registro.codigoSistemaUsuario);
                l += $scope.addProp(registro.codigoSistemaPaciente);
                l += $scope.addProp(registro.imagem);
                l += $scope.addProp(registro.uuidPaciente);

                return l.substring(0, l.length - 1);
            };

            var sql = "SELECT v.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " p.codigoSistema AS codigoSistemaPaciente," +
                " p.uuidTablet AS uuidPaciente" +
                " FROM vacinasImagens v" +
                " LEFT JOIN usuarios AS u ON u.id = v.codigoUsuario " +
                " LEFT JOIN paciente AS p ON p.id = v.codigoPaciente";

            DB.query(sql).then(function (result) {
                var registros = DB.fetchAll(result);
                if (registros.length > 0) {
                    var layout = '';
                    for (var i = 0; i < registros.length; i++) {
                        layout += montarRegistros(registros[i]) + '\n';
                    }
                    SERVER.post('VACINAS_IMAGENS', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarPesquisas = function () {
            var deferred = $q.defer();

            var montarRegistros = function (registro) {
                var l = '';
                l += $scope.addProp(registro.codigoSistema);
                l += $scope.addProp(registro.id);
                l += $scope.addProp(registro.codigoSistemaUsuario);
                l += $scope.addProp(registro.codigoSistemaResposta);
                l += $scope.addProp(registro.codigoSistemaVisita);
                l += $scope.addProp(registro.codigoSistemaPesquisaPergunta);
                l += $scope.addProp(registro.uuidVisita);

                return l.substring(0, l.length - 1);
            };

            var sql = "SELECT p.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " pr.codigoSistema AS codigoSistemaResposta, " +
                " v.codigoSistema AS codigoSistemaVisita, " +
                " v.uuidTablet AS uuidVisita, " +
                " pp.codigoSistema AS codigoSistemaPesquisaPergunta" +
                " FROM pesquisaVisita p" +
                " LEFT JOIN usuarios AS u ON u.id = p.codigoUsuario " +
                " LEFT JOIN perguntaResposta AS pr ON pr.id = p.codigoResposta " +
                " LEFT JOIN visitaDomiciliar AS v ON v.id = p.codigoVisita " +
                " LEFT JOIN pesquisaPergunta AS pp ON pp.id = p.codigoPesquisaPergunta";

            DB.query(sql).then(function (result) {
                var registros = DB.fetchAll(result);
                if (registros.length > 0) {
                    var layout = '';
                    for (var i = 0; i < registros.length; i++) {
                        layout += montarRegistros(registros[i]) + '\n';
                    }
                    SERVER.post('PESQUISA_VISITA', layout).then(function (data, status, headers) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarDocumentos = function () {
            var deferred = $q.defer();

            var montarDocumentos = function (documentos) {
                var l = '';
                l += $scope.addProp(documentos.codigoSistema);
                l += $scope.addProp(documentos.id);
                if (isInvalid(documentos.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(documentos.codigoSistemaUsuario);
                }
                l += $scope.addProp(documentos.tipoDocumento);
                l += $scope.addProp(documentos.numeroDocumento);
                l += $scope.addProp(documentos.complemento);
                l += $scope.addProp(documentos.codigoSistemaOrgaoEmissor);
                l += $scope.addProp(documentos.numeroCartorio);
                l += $scope.addProp(documentos.numeroLivro);
                l += $scope.addProp(documentos.numeroFolha);
                l += $scope.addProp(documentos.numeroTermo);
                l += $scope.addProp(documentos.numeroMatricula);
                l += $scope.addProp(documentos.dataEmissaoFormatada);
                l += $scope.addProp(documentos.siglaUf);
                l += $scope.addProp(documentos.codigoSistemaPaciente);
                l += $scope.addProp(documentos.excluido);
                l += $scope.addProp(documentos.uuidPaciente);

                return l.substring(0, l.length - 1);
            };
            //DOCUMENTOS
            var sql = "SELECT doc.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " p.codigoSistema AS codigoSistemaPaciente," +
                " p.uuidTablet AS uuidPaciente," +
                " oe.codigoSistema AS codigoSistemaOrgaoEmissor," +
                " strftime('%d-%m-%Y', doc.dataEmissao, 'unixepoch') AS dataEmissaoFormatada" +
                " FROM documentos doc" +
                " LEFT JOIN paciente AS p ON p.id = doc.codigoPaciente " +
                " LEFT JOIN usuarios AS u ON u.id = doc.codigoUsuario " +
                " LEFT JOIN orgaoEmissor AS oe ON oe.id = doc.codigoOrgaoEmissor " +
                " WHERE (doc.versaoMobile > ? OR doc.codigoSistema is null)";

            DB.query(sql, [0]).then(function (result) {
                var documentos = DB.fetchAll(result);
                if (documentos.length > 0) {
                    var layout = '';
                    for (var i = 0; i < documentos.length; i++) {
                        layout += montarDocumentos(documentos[i]) + '\n';
                    }
                    SERVER.post('documentos', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarCns = function () {
            var deferred = $q.defer();

            var montarCns = function (cns) {
                var l = '';
                l += $scope.addProp(cns.codigoSistema);
                l += $scope.addProp(cns.id);
                if (isInvalid(cns.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(cns.codigoSistemaUsuario);
                }
                l += $scope.addProp(cns.numeroCartao);
                l += $scope.addProp(cns.codigoSistemaPaciente);
                l += $scope.addProp(cns.excluido);
                l += $scope.addProp(cns.uuidPaciente);

                return l.substring(0, l.length - 1);
            };
            //CNS
            var sql = "SELECT cns.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " p.codigoSistema AS codigoSistemaPaciente," +
                " p.uuidTablet AS uuidPaciente" +
                " FROM Cns cns" +
                " LEFT JOIN paciente AS p ON p.id = cns.codigoPaciente " +
                " LEFT JOIN usuarios AS u ON u.id = cns.codigoUsuario " +
                " WHERE (cns.versaoMobile > ? OR cns.codigoSistema is null)";

            DB.query(sql, [0]).then(function (result) {
                var cns = DB.fetchAll(result);
                if (cns.length > 0) {
                    var layout = '';
                    for (var i = 0; i < cns.length; i++) {
                        layout += montarCns(cns[i]) + '\n';
                    }
                    SERVER.post('cns', layout).then(function (data) {
                        return deferred.resolve();
                    }, function (e, status) {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarPacienteDado = function () {
            var deferred = $q.defer();

            var montarPacienteDado = function (pacienteDado) {
                var l = '';
                l += $scope.addProp(null);
                l += $scope.addProp(pacienteDado.codigoSistemaPaciente);
                if (isInvalid(pacienteDado.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(pacienteDado.codigoSistemaUsuario);
                }
                l += $scope.addProp(pacienteDado.dataColetaFormatada);
                l += $scope.addProp(pacienteDado.peso);
                l += $scope.addProp(pacienteDado.altura);
                l += $scope.addProp(pacienteDado.uuidPaciente);

                return l.substring(0, l.length - 1);
            };
            //PACIENTE DADO
            var sql = "SELECT pd.*, " +
                " strftime('%d-%m-%Y %H:%M:%S', pd.dataColeta, 'unixepoch') AS dataColetaFormatada," +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " p.codigoSistema AS codigoSistemaPaciente," +
                " p.uuidTablet AS uuidPaciente" +
                " FROM PacienteDado pd" +
                " LEFT JOIN paciente AS p ON p.id = pd.codigoPaciente " +
                " LEFT JOIN usuarios AS u ON u.id = pd.codigoUsuario " +
                " WHERE pd.versaoMobile > ?";

            DB.query(sql, [0]).then(function (result) {
                var pd = DB.fetchAll(result);
                if (pd.length > 0) {
                    var layout = '';
                    for (var i = 0; i < pd.length; i++) {
                        layout += montarPacienteDado(pd[i]) + '\n';
                    }
                    SERVER.post('paciente_dado', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarPacienteEsus = function () {
            var deferred = $q.defer();

            var montarPacienteEsus = function (pacienteEsus) {
                var l = '';
                l += $scope.addProp(pacienteEsus.codigoSistema);
                l += $scope.addProp(pacienteEsus.id);
                if (isInvalid(pacienteEsus.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(pacienteEsus.codigoSistemaUsuario);
                }
                l += $scope.addProp(pacienteEsus.codigoSistemaPaciente);
                l += $scope.addProp(pacienteEsus.dataCadastroFormatada);
                l += $scope.addProp(pacienteEsus.situacaoConjugal);
                l += $scope.addProp(pacienteEsus.codigoSistemaCbo);
                l += $scope.addProp(pacienteEsus.frequentaEscola);
                l += $scope.addProp(pacienteEsus.nivelEscolaridade);
                l += $scope.addProp(pacienteEsus.situacaoMercadoTrabalho);
                l += $scope.addProp(pacienteEsus.responsavelCrianca);
                l += $scope.addProp(pacienteEsus.frequentaCurandeira);
                l += $scope.addProp(pacienteEsus.participaGrupoComunitario);
                l += $scope.addProp(pacienteEsus.possuiPlanoSaude);
                l += $scope.addProp(pacienteEsus.membroComunidadeTradicional);
                l += $scope.addProp(pacienteEsus.comunidadeTradicional);
                l += $scope.addProp(pacienteEsus.orientacaoSexual);
                l += $scope.addProp(pacienteEsus.deficienciaAuditiva);
                l += $scope.addProp(pacienteEsus.deficienciaVisual);
                l += $scope.addProp(pacienteEsus.deficienciaFisica);
                l += $scope.addProp(pacienteEsus.deficienciaIntelectual);
                l += $scope.addProp(pacienteEsus.deficienciaOutra);
                l += $scope.addProp(pacienteEsus.situacaoRua);
                l += $scope.addProp(pacienteEsus.tempoRua);
                l += $scope.addProp(pacienteEsus.acompanhadoPorOutraInstituicao);
                l += $scope.addProp(pacienteEsus.nomeOutraInstituicao);
                l += $scope.addProp(pacienteEsus.recebeBeneficio);
                l += $scope.addProp(pacienteEsus.possuiReferenciaFamiliar);
                l += $scope.addProp(pacienteEsus.visitaFamiliarFrequentemente);
                l += $scope.addProp(pacienteEsus.grauParentesco);
                l += $scope.addProp(pacienteEsus.refeicoesDia);
                l += $scope.addProp(pacienteEsus.refeicaoRestaurantePopular);
                l += $scope.addProp(pacienteEsus.refeicaoDoacaoRestaurante);
                l += $scope.addProp(pacienteEsus.refeicaoDoacaoReligioso);
                l += $scope.addProp(pacienteEsus.refeicaoDoacaoPopular);
                l += $scope.addProp(pacienteEsus.refeicaoDoacaoOutros);
                l += $scope.addProp(pacienteEsus.acessoHigienePessoal);
                l += $scope.addProp(pacienteEsus.higieneBanho);
                l += $scope.addProp(pacienteEsus.higieneSanitario);
                l += $scope.addProp(pacienteEsus.higieneBucal);
                l += $scope.addProp(pacienteEsus.higieneOutros);
                l += $scope.addProp(pacienteEsus.estaGestante);
                l += $scope.addProp(pacienteEsus.maternidadeReferencia);
                l += $scope.addProp(pacienteEsus.pesoConsiderado);
                l += $scope.addProp(pacienteEsus.fumante);
                l += $scope.addProp(pacienteEsus.dependenteAlcool);
                l += $scope.addProp(pacienteEsus.dependenteDroga);
                l += $scope.addProp(pacienteEsus.temHipertensao);
                l += $scope.addProp(pacienteEsus.temDiabetes);
                l += $scope.addProp(pacienteEsus.teveAvc);
                l += $scope.addProp(pacienteEsus.teveInfarto);
                l += $scope.addProp(pacienteEsus.temHanseniase);
                l += $scope.addProp(pacienteEsus.temTuberculose);
                l += $scope.addProp(pacienteEsus.temTeveCancer);
                l += $scope.addProp(pacienteEsus.internacaoAno);
                l += $scope.addProp(pacienteEsus.causaInternacao);
                l += $scope.addProp(pacienteEsus.fezTratamentoPsiquiatrico);
                l += $scope.addProp(pacienteEsus.estaAcamado);
                l += $scope.addProp(pacienteEsus.estaDomiciliado);
                l += $scope.addProp(pacienteEsus.usaPlantasMedicinais);
                l += $scope.addProp(pacienteEsus.quaisPlantas);
                l += $scope.addProp(pacienteEsus.doencaCardiaca);
                l += $scope.addProp(pacienteEsus.cardiacaInsuficiencia);
                l += $scope.addProp(pacienteEsus.cardiacaOutros);
                l += $scope.addProp(pacienteEsus.cardiacaNaoSabe);
                l += $scope.addProp(pacienteEsus.doencaRins);
                l += $scope.addProp(pacienteEsus.rinsInsuficiencia);
                l += $scope.addProp(pacienteEsus.rinsOutros);
                l += $scope.addProp(pacienteEsus.rinsNaoSabe);
                l += $scope.addProp(pacienteEsus.doencaRespiratoria);
                l += $scope.addProp(pacienteEsus.respiratoriaAsma);
                l += $scope.addProp(pacienteEsus.respiratoriaEfisema);
                l += $scope.addProp(pacienteEsus.respiratoriaOutros);
                l += $scope.addProp(pacienteEsus.respiratoriaNaoSabe);
                l += $scope.addProp(pacienteEsus.outrasPraticasIntegrativas);
                l += $scope.addProp(pacienteEsus.condicaoSaude1);
                l += $scope.addProp(pacienteEsus.condicaoSaude2);
                l += $scope.addProp(pacienteEsus.condicaoSaude3);
                l += $scope.addProp(pacienteEsus.possuiDeficiencia);
                l += $scope.addProp(pacienteEsus.informaOrientacaoSexual);
                l += $scope.addProp(pacienteEsus.possuiSofrimentoPsiquicoGrave);
                l += $scope.addProp(pacienteEsus.utilizaProtese);
                l += $scope.addProp(pacienteEsus.proteseAuditiva);
                l += $scope.addProp(pacienteEsus.proteseMembrosSuperiores);
                l += $scope.addProp(pacienteEsus.proteseMembrosInferiores);
                l += $scope.addProp(pacienteEsus.proteseCadeiraRodas);
                l += $scope.addProp(pacienteEsus.proteseOutros);
                l += $scope.addProp(pacienteEsus.parentescoResponsavel);
                l += $scope.addProp(pacienteEsus.uuidPaciente);

                l += $scope.addProp(pacienteEsus.paiDesconhecido);
                l += $scope.addProp(pacienteEsus.maeDesconhecida);
                l += $scope.addProp(pacienteEsus.dataNaturalizadoFormatada);
                l += $scope.addProp(pacienteEsus.portariaNaturalizacao);
                l += $scope.addProp(pacienteEsus.dtEntradaBrasilFormatada);
                // l += $scope.addProp(pacienteEsus.flagForaArea);
                l += $scope.addProp(pacienteEsus.dataObitoFormatada);
                l += $scope.addProp(pacienteEsus.numeroDO);
                l += $scope.addProp(pacienteEsus.identidadeGenero);

                return l.substring(0, l.length - 1);
            };
            //PacienteEsus
            var sql = "SELECT pe.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " p.codigoSistema AS codigoSistemaPaciente," +
                " p.uuidTablet AS uuidPaciente," +
                " strftime('%d-%m-%Y', pe.dataCadastro, 'unixepoch') AS dataCadastroFormatada," +
                " strftime('%d-%m-%Y', pe.dataNaturalizacao, 'unixepoch') AS dataNaturalizadoFormatada," +
                " strftime('%d-%m-%Y', pe.dtEntradaBrasil, 'unixepoch') AS dtEntradaBrasilFormatada," +
                " strftime('%d-%m-%Y', pe.dataObito, 'unixepoch') AS dataObitoFormatada," +
                " cbo.codigoSistema AS codigoSistemaCbo" +
                " FROM pacienteEsus pe" +
                " LEFT JOIN paciente AS p ON p.id = pe.codigoPaciente " +
                " LEFT JOIN usuarios AS u ON u.id = pe.codigoUsuario " +
                " LEFT JOIN cbo AS cbo ON cbo.id = pe.codigoCbo " +
                " WHERE (pe.versaoMobile > ? OR pe.codigoSistema is null)";

            DB.query(sql, [0]).then(function (result) {
                var pacienteEsus = DB.fetchAll(result);
                if (pacienteEsus.length > 0) {
                    var layout = '';
                    for (var i = 0; i < pacienteEsus.length; i++) {
                        layout += montarPacienteEsus(pacienteEsus[i]) + '\n';
                    }
                    SERVER.post('paciente_esus', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarPacientes = function () {
            var deferred = $q.defer();

            var montarPacientes = function (paciente) {
                var l = '';
                l += $scope.addProp(paciente.codigoSistema);
                l += $scope.addProp(paciente.id);
                if (isInvalid(paciente.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(paciente.codigoSistemaUsuario);
                }
                l += $scope.addProp(paciente.excluido);
                l += $scope.addProp(paciente.nome);
                l += $scope.addProp(paciente.dataNascimentoFormatada);
                l += $scope.addProp(paciente.sexo);
                l += $scope.addProp(paciente.nomeMae);
                l += $scope.addProp(paciente.codigoCidadeNascimentoSistema);
                l += $scope.addProp(paciente.cpf);
                l += $scope.addProp(paciente.rg);
                l += $scope.addProp(paciente.telefone);
                l += $scope.addProp(paciente.celular);
                l += $scope.addProp(paciente.codigoRacaSistema);
                l += $scope.addProp(paciente.codigoPaisNascimentoSistema);
                l += $scope.addProp(paciente.email);
                l += $scope.addProp(paciente.apelido);
                l += $scope.addProp(paciente.flagResponsavelFamiliar);
                l += $scope.addProp(paciente.codigoResponsavelSistema);
                l += $scope.addProp(paciente.nacionalidade);
                l += $scope.addProp(paciente.codigoDomicilioSistema);
                l += $scope.addProp(paciente.telefone2);
                l += $scope.addProp(paciente.telefone3);
                l += $scope.addProp(paciente.telefone4);
                l += $scope.addProp(paciente.religiao);
                l += $scope.addProp(paciente.localTrabalho);
                l += $scope.addProp(paciente.telefoneTrabalho);
                l += $scope.addProp(paciente.paciente);
                l += $scope.addProp(paciente.parentescoResponsavel);
                l += $scope.addProp(paciente.urgenciaNome);
                l += $scope.addProp(paciente.urgenciaTelefone);
                l += $scope.addProp(paciente.urgenciaParentesco);
                l += $scope.addProp(paciente.rendaFamiliar);
                if (invalidToEmpty(paciente.resideDesdeFormatado).length > 10) {
                    l += $scope.addProp('');
                } else {
                    l += $scope.addProp(paciente.resideDesdeFormatado);
                }
                l += $scope.addProp(paciente.situacao);
                l += $scope.addProp(paciente.nis);
                l += $scope.addProp(paciente.prontuario);
                l += $scope.addProp(paciente.motivoExclusaoDomicilio);
                l += $scope.addProp(paciente.motivoExclusao);
                l += $scope.addProp(paciente.codigoEtniaIndigena);

                l += $scope.addProp(paciente.numeroRG);
                l += $scope.addProp(paciente.numeroCPF);
                l += $scope.addProp(paciente.codigoOrgaoEmissor);
                l += $scope.addProp(paciente.siglaUf);
                l += $scope.addProp(paciente.folha);
                l += $scope.addProp(paciente.livro);
                l += $scope.addProp(paciente.termo);
                l += $scope.addProp(paciente.dtEmissaoRG);
                l += $scope.addProp(paciente.dtEmissaoCertidao);
                l += $scope.addProp(paciente.tpCertidao);
                l += $scope.addProp(paciente.nrCns);

                l += $scope.addProp(paciente.uuidTablet);
                l += $scope.addProp(paciente.uuidResponsavel);
                l += $scope.addProp(paciente.uuidDomicilio);

                l += $scope.addProp(paciente.nomePai);

                return l.substring(0, l.length - 1);
            };
            //Pacientes
            var sql = "SELECT p.*, " +
                "u.codigoSistema AS codigoSistemaUsuario, " +
                "strftime('%d-%m-%Y', p.dataNascimento, 'unixepoch') AS dataNascimentoFormatada, " +
                "strftime('%d-%m-%Y', p.resideDesde, 'unixepoch') AS resideDesdeFormatado, " +
                "c.codigoSistema AS codigoCidadeNascimentoSistema, " +
                "pais.codigoSistema AS codigoPaisNascimentoSistema, " +
                "resp.codigoSistema AS codigoResponsavelSistema, " +
                "resp.uuidTablet AS uuidResponsavel, " +
                "raca.codigoSistema AS codigoRacaSistema, " +
                "etniaIndigena.codigoSistema AS codigoEtniaIndigenaSistema, " +
                "dom.codigoSistema AS codigoDomicilioSistema, " +
                "dom.uuidTablet AS uuidDomicilio, " +
                "rg.numeroDocumento as numeroRG, " +
                "cpf.numeroDocumento as numeroCPF, " +
                "oe.codigoSistema as codigoOrgaoEmissor, " +
                "rg.siglaUf as siglaUf, " +
                "certidao.numeroFolha as folha, " +
                "certidao.numeroLivro as livro, " +
                "certidao.numeroTermo as termo, " +
                "strftime('%d-%m-%Y', certidao.dataEmissao, 'unixepoch') as dtEmissaoCertidao, " +
                "strftime('%d-%m-%Y', rg.dataEmissao, 'unixepoch') as dtEmissaoRG, " +
                "certidao.tipoDocumento as tpCertidao, " +
                "cns.numeroCartao as nrCns " +
                "FROM paciente p " +
                "LEFT JOIN usuarios AS u ON u.id = p.codigoUsuario " +
                "LEFT JOIN cidade AS c ON c.id = p.codigoCidade " +
                "LEFT JOIN pais AS pais ON pais.id = p.codigoPais " +
                "LEFT JOIN raca AS raca ON raca.id = p.codigoRaca " +
                "LEFT JOIN etniaIndigena AS etniaIndigena ON etniaIndigena.id = p.codigoEtniaIndigena " +
                "LEFT JOIN domicilio AS dom ON dom.id = p.codigoDomicilio " +
                "LEFT JOIN paciente AS resp ON resp.id = p.codigoResponsavelFamiliar 	" +
                "LEFT JOIN documentos AS rg ON rg.codigoPaciente = p.id AND rg.tipoDocumento = 1 " +
                "LEFT JOIN documentos AS cpf ON cpf.codigoPaciente = p.id AND cpf.tipoDocumento = 2 " +
                "LEFT JOIN documentos AS certidao ON certidao.codigoPaciente = p.id AND certidao.tipoDocumento > 90 " +
                "LEFT JOIN cns as cns on cns.codigoPaciente = p.id AND cns.excluido = 'N' " +
                "LEFT JOIN orgaoEmissor oe ON oe.id = rg.codigoOrgaoEmissor " +
                "WHERE coalesce(p.flagResponsavelFamiliar, 0) <> 1 AND (p.versaoMobile > ? OR p.codigoSistema is null) " +
                "GROUP BY p.id";

            DB.query(sql, [0]).then(function (result) {
                var pacientes = DB.fetchAll(result);
                if (pacientes.length > 0) {
                    var layout = '';
                    for (var i = 0; i < pacientes.length; i++) {
                        layout += montarPacientes(pacientes[i]) + '\n';
                    }
                    SERVER.post('pacientev2', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarResponsaveis = function () {
            var deferred = $q.defer();

            var montarResponsaveis = function (responsavel) {
                var l = '';
                l += $scope.addProp(responsavel.codigoSistema);
                l += $scope.addProp(responsavel.id);
                if (isInvalid(responsavel.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(responsavel.codigoSistemaUsuario);
                }
                l += $scope.addProp(responsavel.excluido);
                l += $scope.addProp(responsavel.nome);
                l += $scope.addProp(responsavel.dataNascimentoFormatada);
                l += $scope.addProp(responsavel.sexo);
                l += $scope.addProp(responsavel.nomeMae);
                l += $scope.addProp(responsavel.codigoCidadeNascimentoSistema);
                l += $scope.addProp(responsavel.cpf);
                l += $scope.addProp(responsavel.rg);
                l += $scope.addProp(responsavel.telefone);
                l += $scope.addProp(responsavel.celular);
                l += $scope.addProp(responsavel.codigoRacaSistema);
                l += $scope.addProp(responsavel.codigoPaisNascimentoSistema);
                l += $scope.addProp(responsavel.email);
                l += $scope.addProp(responsavel.apelido);
                l += $scope.addProp(responsavel.flagResponsavelFamiliar);
                l += $scope.addProp(null);
                l += $scope.addProp(responsavel.nacionalidade);
                l += $scope.addProp(responsavel.codigoDomicilioSistema);
                l += $scope.addProp(responsavel.telefone2);
                l += $scope.addProp(responsavel.telefone3);
                l += $scope.addProp(responsavel.telefone4);
                l += $scope.addProp(responsavel.religiao);
                l += $scope.addProp(responsavel.localTrabalho);
                l += $scope.addProp(responsavel.telefoneTrabalho);
                l += $scope.addProp(responsavel.responsavel);
                l += $scope.addProp(responsavel.parentescoResponsavel);
                l += $scope.addProp(responsavel.urgenciaNome);
                l += $scope.addProp(responsavel.urgenciaTelefone);
                l += $scope.addProp(responsavel.urgenciaParentesco);
                l += $scope.addProp(responsavel.rendaFamiliar);
                l += $scope.addProp(responsavel.resideDesdeFormatado);
                l += $scope.addProp(responsavel.situacao);
                l += $scope.addProp(responsavel.nis);
                l += $scope.addProp(responsavel.prontuario);
                l += $scope.addProp(responsavel.motivoExclusaoDomicilio);
                l += $scope.addProp(responsavel.motivoExclusao);
                l += $scope.addProp(responsavel.codigoEtniaIndigena);

                //Documentos

                l += $scope.addProp(responsavel.numeroRG);
                l += $scope.addProp(responsavel.numeroCPF);
                l += $scope.addProp(responsavel.codigoOrgaoEmissor);
                l += $scope.addProp(responsavel.siglaUf);
                l += $scope.addProp(responsavel.folha);
                l += $scope.addProp(responsavel.livro);
                l += $scope.addProp(responsavel.termo);
                l += $scope.addProp(responsavel.dtEmissaoRG);
                l += $scope.addProp(responsavel.dtEmissaoCertidao);
                l += $scope.addProp(responsavel.tpCertidao);
                l += $scope.addProp(responsavel.nrCns);
                l += $scope.addProp(responsavel.uuidTablet);
                l += $scope.addProp(null);
                l += $scope.addProp(responsavel.uuidDomicilio);
                l += $scope.addProp(responsavel.nomePai);

                return l.substring(0, l.length - 1);
            };
            //Responsaveis
            var sql = "SELECT DISTINCT p.*, " +
                "u.codigoSistema AS codigoSistemaUsuario, " +
                "strftime('%d-%m-%Y', p.dataNascimento, 'unixepoch') AS dataNascimentoFormatada, " +
                "strftime('%d-%m-%Y', p.resideDesde, 'unixepoch') AS resideDesdeFormatado, " +
                "c.codigoSistema AS codigoCidadeNascimentoSistema, " +
                "pais.codigoSistema AS codigoPaisNascimentoSistema, " +
                "p.codigoSistema AS codigoResponsavelSistema, " +
                "raca.codigoSistema AS codigoRacaSistema, " +
                "etniaIndigena.codigoSistema AS codigoEtniaIndigenaSistema, " +
                "dom.codigoSistema AS codigoDomicilioSistema, " +
                "dom.uuidTablet AS uuidDomicilio, " +
                "rg.numeroDocumento as numeroRG, " +
                "cpf.numeroDocumento as numeroCPF, " +
                "oe.codigoSistema as codigoOrgaoEmissor, " +
                "rg.siglaUf as siglaUf, " +
                "certidao.numeroFolha as folha, " +
                "certidao.numeroLivro as livro, " +
                "certidao.numeroTermo as termo, " +
                "strftime('%d-%m-%Y', certidao.dataEmissao, 'unixepoch') as dtEmissaoCertidao, " +
                "strftime('%d-%m-%Y', rg.dataEmissao, 'unixepoch') as dtEmissaoRG, " +
                "certidao.tipoDocumento as tpCertidao, " +
                "cns.numeroCartao as nrCns " +
                "FROM paciente p " +
                "LEFT JOIN usuarios AS u ON u.id = p.codigoUsuario  " +
                "LEFT JOIN cidade AS c ON c.id = p.codigoCidade  " +
                "LEFT JOIN pais AS pais ON pais.id = p.codigoPais  " +
                "LEFT JOIN raca AS raca ON raca.id = p.codigoRaca  " +
                "LEFT JOIN etniaIndigena AS etniaIndigena ON etniaIndigena.id = p.codigoEtniaIndigena  " +
                "LEFT JOIN domicilio AS dom ON dom.id = p.codigoDomicilio  " +
                "LEFT JOIN documentos AS rg ON rg.codigoPaciente = p.id AND rg.tipoDocumento = 1 " +
                "LEFT JOIN documentos AS cpf ON cpf.codigoPaciente = p.id AND cpf.tipoDocumento = 2  " +
                "LEFT JOIN documentos AS certidao ON certidao.codigoPaciente = p.id AND certidao.tipoDocumento > 90 " +
                "LEFT JOIN cns as cns on cns.codigoPaciente = p.id " +
                "LEFT JOIN orgaoEmissor as oe ON oe.id = rg.codigoOrgaoEmissor " +
                "WHERE coalesce(p.flagResponsavelFamiliar,0) = 1 AND (p.versaoMobile > ? OR p.codigoSistema is null) ORDER BY p.id";

            DB.query(sql, [0]).then(function (result) {
                var responsaveis = DB.fetchAll(result);
                if (responsaveis.length > 0) {
                    var layout = '';
                    for (var i = 0; i < responsaveis.length; i++) {
                        layout += montarResponsaveis(responsaveis[i]) + '\n';
                    }
                    SERVER.post('pacientev2', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarDomicilioEsus = function () {
            var deferred = $q.defer();

            var montarDomicilioEsus = function (domicilioEsus) {
                var l = '';
                l += $scope.addProp(domicilioEsus.codigoSistema);
                l += $scope.addProp(domicilioEsus.id);
                if (isInvalid(domicilioEsus.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(domicilioEsus.codigoSistemaUsuario);
                }
                l += $scope.addProp(domicilioEsus.codigoDomicilioSistema);
                l += $scope.addProp(domicilioEsus.situacaoMoradia);
                l += $scope.addProp(domicilioEsus.localizacao);
                l += $scope.addProp(domicilioEsus.tipoDomicilio);
                l += $scope.addProp(domicilioEsus.numeroMoradores);
                l += $scope.addProp(domicilioEsus.numeroComodos);
                l += $scope.addProp(domicilioEsus.condicaoUsoTerra);
                l += $scope.addProp(domicilioEsus.tipoAcessoDomicilio);
                l += $scope.addProp(domicilioEsus.materialDominante);
                l += $scope.addProp(domicilioEsus.possuiEnergiaEletrica);
                l += $scope.addProp(domicilioEsus.abastecimentoAgua);
                l += $scope.addProp(domicilioEsus.tratamentoAgua);
                l += $scope.addProp(domicilioEsus.esgotamento);
                l += $scope.addProp(domicilioEsus.destinoLixo);
                l += $scope.addProp(domicilioEsus.gato);
                l += $scope.addProp(domicilioEsus.cachorro);
                l += $scope.addProp(domicilioEsus.passaro);
                l += $scope.addProp(domicilioEsus.criacao);
                l += $scope.addProp(domicilioEsus.outros);
                l += $scope.addProp(domicilioEsus.quantos);
                l += $scope.addProp(domicilioEsus.dataGpsFormatada);
                l += $scope.addProp(domicilioEsus.horaGpsFormatada);
                l += $scope.addProp(domicilioEsus.latitude);
                l += $scope.addProp(domicilioEsus.longitude);
                l += $scope.addProp(domicilioEsus.uuidTablet);
                l += $scope.addProp(domicilioEsus.uuidDomicilioSistema);

                l += $scope.addProp(domicilioEsus.tipoImovel);
                l += $scope.addProp(domicilioEsus.nomeInstituicao);
                l += $scope.addProp(domicilioEsus.flagOutrosProfissionais);
                l += $scope.addProp(domicilioEsus.nomeResponsavelTecnico);
                l += $scope.addProp(domicilioEsus.numeroCartaoResponsavelTecnico);
                l += $scope.addProp(domicilioEsus.cargoResponsavelTecnico);
                l += $scope.addProp(domicilioEsus.telefoneResponsavelTecnico);

                // l += $scope.addProp(domicilioEsus.flagForaArea);

                return l.substring(0, l.length - 1);
            };
            //Domicilio Esus
            var sql = "SELECT de.*, " +
                " strftime('%d-%m-%Y', de.dataColetaGps, 'unixepoch') AS dataGpsFormatada," +
                " strftime('%H:%M:%S', de.dataColetaGps, 'unixepoch', 'localtime') AS horaGpsFormatada," +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " d.codigoSistema AS codigoDomicilioSistema," +
                " d.uuidTablet    AS uuidDomicilioSistema" +
                " FROM domicilioEsus de" +
                " LEFT JOIN domicilio AS d ON d.id = de.codigoDomicilio " +
                " LEFT JOIN usuarios AS u ON u.id = de.codigoUsuario " +
                " WHERE (de.versaoMobile > ? OR de.codigoSistema is null)";

            DB.query(sql, [0]).then(function (result) {
                var domiciliosEsus = DB.fetchAll(result);
                if (domiciliosEsus.length > 0) {
                    var layout = '';
                    for (var i = 0; i < domiciliosEsus.length; i++) {
                        layout += montarDomicilioEsus(domiciliosEsus[i]) + '\n';
                    }
                    SERVER.post('domicilio_esus', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.enviarDomicilio = function () {
            var deferred = $q.defer();

            var montarDomicilio = function (domicilio) {
                var l = '';
                l += $scope.addProp(domicilio.codigoSistema);
                l += $scope.addProp(domicilio.id);
                if (isInvalid(domicilio.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(domicilio.codigoSistemaUsuario);
                }
                l += $scope.addProp(domicilio.codigoEnderecoSistema);
                l += $scope.addProp(domicilio.numeroFamilia);
                l += $scope.addProp(domicilio.codigoMicroAreaSistema);
                l += $scope.addProp(domicilio.uuidTablet);
                l += $scope.addProp(domicilio.uuidEnderecoSistema);

                return l.substring(0, l.length - 1);
            };
            //Domicilio
            var sql = "SELECT d.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " e.codigoSistema AS codigoEnderecoSistema," +
                " e.uuidTablet    AS uuidEnderecoSistema," +
                " ma.codigoSistema AS codigoMicroAreaSistema" +
                " FROM domicilio d" +
                " LEFT JOIN usuarios AS u ON u.id = d.codigoUsuario " +
                " LEFT JOIN endereco AS e ON e.id = d.codigoEndereco " +
                " LEFT JOIN microArea AS ma ON ma.id = d.codigoMicroArea " +
                " WHERE (d.versaoMobile > ? OR d.codigoSistema is null)";

            DB.query(sql, [0]).then(function (result) {
                var domicilios = DB.fetchAll(result);
                if (domicilios.length > 0) {
                    var layout = '';
                    for (var i = 0; i < domicilios.length; i++) {
                        layout += montarDomicilio(domicilios[i]) + '\n';
                    }
                    SERVER.post('domicilio', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        $scope.abrirLote = function () {
            //  var deferred = $q.defer();
            var url = dataService.data.url + G_versao + '/' + G_id + '/abrirLote?codigoProfissional=' + storageService.getItem("codigoProfissional") + "&versaoMobile=" + storageService.getItem("versaoLocal");
            return $http({
                url: url,
                method: 'POST',
                transformResponse: [function (data) {
                    return data;
                }]
            });;
        }

        $scope.fecharLote = function () {
            //  var deferred = $q.defer();
            var url = dataService.data.url + G_versao + '/' + G_id + '/fecharLote?codigoProfissional=' + storageService.getItem("codigoProfissional");
            return $http.post(url);
        }

        $scope.enviarEndereco = function () {
            var deferred = $q.defer();

            var montarEndereco = function (endereco) {
                var l = '';
                l += $scope.addProp(endereco.codigoSistema);
                l += $scope.addProp(endereco.id);
                if (isInvalid(endereco.codigoSistemaUsuario)) {
                    l += $scope.addProp($scope.usuarioLogado.codigoSistema);
                } else {
                    l += $scope.addProp(endereco.codigoSistemaUsuario);
                }
                l += $scope.addProp(endereco.codigoCidadeSistema);
                l += $scope.addProp(endereco.cep);
                l += $scope.addProp(endereco.bairro);
                l += $scope.addProp(endereco.codigoTipoLogradouroSistema);
                l += $scope.addProp(endereco.logradouro);
                l += $scope.addProp(endereco.complementoLogradouro);
                l += $scope.addProp(endereco.numeroLogradouro);
                l += $scope.addProp(endereco.telefone);
                l += $scope.addProp(endereco.telefoneReferencia);
                l += $scope.addProp(endereco.pontoReferencia);
                l += $scope.addProp(endereco.uuidTablet);

                return l.substring(0, l.length - 1);
            };
            //Endereco
            var sql = "SELECT e.*, " +
                " u.codigoSistema AS codigoSistemaUsuario," +
                " c.codigoSistema AS codigoCidadeSistema," +
                " tl.codigoSistema AS codigoTipoLogradouroSistema" +
                " FROM endereco e" +
                " LEFT JOIN usuarios AS u ON u.id = e.codigoUsuario " +
                " LEFT JOIN cidade AS c ON c.id = e.codigoCidade " +
                " LEFT JOIN tipoLogradouro AS tl ON tl.id = e.codigoTipoLogradouro " +
                " WHERE (e.versaoMobile > ? OR e.codigoSistema is null)";

            DB.query(sql, [0]).then(function (result) {
                var enderecos = DB.fetchAll(result);
                if (enderecos.length > 0) {
                    var layout = '';
                    for (var i = 0; i < enderecos.length; i++) {
                        layout += montarEndereco(enderecos[i]) + '\n';
                    }
                    SERVER.post('endereco', layout).then(function (data) {
                        return deferred.resolve();
                    }, function () {
                        return deferred.reject();
                    });
                } else {
                    return deferred.resolve();
                }
            });

            return deferred.promise;
        };

        function ressincronizarRecriar() {
            if (storageService.getItem("sincronizacaoFinalizada")) {
                $scope.enviarRecursos();
                return;
            }
            sincronizacaoService.carregarVersoes();
        }

        $scope.iniciarSincronizacao = function () {
            dataService.data.log.unshift('Iniciando processo de sincronização...');
            getParams()
            DB.deleteVersionTriggers().then(function () {
                ressincronizarRecriar();
            });
        };

    }
]);