services.factory('googleAnalyticsService', function ($rootScope, validacaoService) {
    var googleAnalyticsService = this;

    const Dimensao = {
        URL: 1,
        ID_USUARIO: 2

    };

    var _extractHostname = function (url) {
        var hostname;
        //find & remove protocol (http, ftp, etc.) and get hostname

        if (url.indexOf("://") > -1) {
            hostname = url.split('/')[2];
        } else {
            hostname = url.split('/')[0];
        }

        //find & remove port number
        hostname = hostname.split(':')[0];
        //find & remove "?"
        hostname = hostname.split('?')[0];

        return hostname;
    };

    var _setup = function () {
        var usuario = JSON.parse(window.localStorage.getItem("usuarioLogado"));
        var usuarioFormatado = "[" + usuario.id + "] " + usuario.login;
        var url = window.localStorage.getItem("url");
        var urlFormatado = _extractHostname(url);
        window.ga.setUserId(urlFormatado + " - " + usuarioFormatado);
        window.ga.setAppVersion(window.localStorage.versaoLocal);
        window.ga.addCustomDimension(Dimensao.URL, url);
        window.ga.addCustomDimension(Dimensao.ID_USUARIO, usuarioFormatado);
    };

    if (!validacaoService.isDev()) {
        $rootScope.$on('$stateChangeStart',
            function (event, toState, toParams, fromState, fromParams) {
                setTimeout(function () {
                    googleAnalyticsService.rastrearTela(toState.name);
                    googleAnalyticsService.dispararEvento(toState.name, "Acesso a view");
                }, 500);
            });
    }


    googleAnalyticsService.dispararEvento = function (categoria, evento) {
        window.ga.trackEvent(categoria, evento);
    };


    googleAnalyticsService.rastrearTela = function (tela) {
        _setup();
        window.ga.trackView(tela);

    };

    return googleAnalyticsService;
});