services.factory('messageService', function ($ionicPopup, $q, dataService) {
    var messageService = this;


    messageService.mostrarConfirmacao = function (mensagem) {
        var deferred = $q.defer();
        var alertPopup = $ionicPopup.confirm({
            title: 'Atenção!',
            template: mensagem,
            buttons: [{
                text: 'Não'
            }, {
                text: '<b>Sim</b>',
                type: 'button-positive',
                onTap: function (e) {
                    return true;
                }
            }]
        });
        alertPopup.then(function (resposta) {
            return deferred.resolve(resposta);
        });

        return deferred.promise;
    };

    messageService.mostrarAlerta = function (mensagem) {
        var alertPopup = $ionicPopup.alert({
            title: 'Atenção!',
            template: mensagem
        });
        alertPopup.then(function (res) {});
    };

    messageService.mostrarMensagem = function (mensagem, msgButton) {
        var deferred = $q.defer();
        var alertPopup = $ionicPopup.confirm({
            title: 'Atenção!',
            template: mensagem,
            buttons: [{
                text: '<b>' + msgButton + '</b>',
                type: 'button-positive',
                onTap: function (e) {
                    return true;
                }
            }]
        });
        alertPopup.then(function (resposta) {
            return deferred.resolve(resposta);
        });

        return deferred.promise;
    };

    //Mensagens de erro
    messageService.mensagensErro = {
        GENERICO: 'Erro genérico:',
        IMPORTAR: 'Erro ao importar',
        EXCLUIR: 'Erro ao excluir',
        LER_ARQUIVO: 'Erro ao ler o arquivo',
        ARQUIVO: 'Erro no arquivo',
        COMUNICACAO_SERVIDOR: 'Houve falha na comunicação com o servidor, verifique sua conexão com a internet',
        SINCRONIZACAO: 'Problemas na sincronização',
        SUPORTE: 'Caso o problema persistir, entre em contato com o suporte',
        PROCESSAR_LOTE: 'Problemas ao processar o lote:',
        RECURSO_DESCONHECIDO: 'Recurso desconhecido: '
    };

    //Mensagens de erro
    messageService.mensagensErro = {
        GENERICO: 'Erro genérico:',
        IMPORTAR: 'Erro ao importar',
        EXCLUIR: 'Erro ao excluir',
        LER_ARQUIVO: 'Erro ao ler o arquivo',
        ARQUIVO: 'Erro no arquivo',
        COMUNICACAO_SERVIDOR: 'Houve falha na comunicação com o servidor, verifique sua conexão com a internet',
        SINCRONIZACAO: 'Problemas na sincronização',
        SUPORTE: 'Caso o problema persistir, entre em contato com o suporte',
        PROCESSAR_LOTE: 'Problemas ao processar o lote:',
        RECURSO_DESCONHECIDO: 'Recurso desconhecido: '
    };

    //Centraliza as mensagens de erros e tratamentos antes e depois dos erros
    messageService.entregaErros = function (tipo,mensagem){
        dataService.data.voltar = true;
        if(mensagem && mensagem.toString().indexOf('\n') > -1){
            var  mensagens = mensagem.split('\n');
            dataService.data.erros.unshift(tipo);
            mensagens.forEach(function (item) {
                dataService.data.erros.unshift(mensagens);
            });
        }else{
            dataService.data.erros.unshift(tipo + ' ' + (mensagem ? mensagem : ''));
        }
    };

    return messageService;
});