services.factory('SERVER', function($http, $q) {
    var self = this;

    self.post = function(recurso, objeto){
        var deferred = $q.defer();
        var url = window.localStorage.getItem("url");
        objeto = objeto.replace(/[\u0010"]/gi, "");

        url += G_versao + '/' + G_id + '/enviarRecurso?nomeRecurso='+recurso;

        if (window.localStorage.codigoProfissional) {

          url += '&codigoProfissional=' + window.localStorage.codigoProfissional;
        }

        if (window.localStorage.versaoLocal) {

          url += '&versaoMobile=' + window.localStorage.versaoLocal;
        }

        var req = {
            method: 'POST',
            url: url,
            headers: {
                'Content-Type': 'text/plain'
            },
            timeout: 1000000,
            data: objeto
        };

        $http(req)
            .success(function (data, status, headers, config) {
                return deferred.resolve(data, status, headers, config);
            }).error(function (data, status, headers, config) {
                return deferred.reject(data, status, headers, config);
            });

        return deferred.promise;
    };


    self.get = function(recurso){
        var deferred = $q.defer();
        var url = window.localStorage.getItem("url");

        var req = {
            method: 'GET',
            url: url + G_versao + '/' + G_id + '/' + recurso,
            headers: {
                'Content-Type': 'text/plain'
            }
        };

        $http(req)
            .success(function (data, status, headers, config) {
                return deferred.resolve(data, status, headers, config);
            }).error(function (data, status, headers, config) {
                return deferred.reject(data, status, headers, config);
            });

        return deferred.promise;
    };

    return self;
});