services.factory('sincronizacaoService', function ($rootScope, $q, $http, $state, $resource, DB, FS, storageService, importacaoService, dataService, messageService) {
    var sincronizacaoService = this;
    //Para vir desabilitado o botao cancelar, habilitar a cada 24h
    if(!storageService.getItem("ultimaConsulta")){
        storageService.setItem("ultimaConsulta", new Date().getTime());
    }
    sincronizacaoService.chamaRespostas = function () {
        delete dataService.data.voltar;
        dataService.data.erros = [];
        if (!dataService.data.processando) {
            if (!dataService.data.processando) {
                var _loteErro = storageService.getItem('loteErro')
                dataService.data.log.unshift('CONSULTANDO RETORNO DO LOTE ' + (_loteErro ? _loteErro : ''));
                if(!storageService.getItem("ultimaConsulta")){
                    storageService.setItem("ultimaConsulta", new Date().getTime());
                }

                // Controla para que o recurso de receber reposta do backend rode um por vez.
                dataService.data.processando = true;

                var url = dataService.data.url + G_versao + '/' + G_id + '/respostas?codigoProfissional=' + storageService.getItem("codigoProfissional");
                $http.post(url).then(function (data) {
                    data = data.data;
                    storageService.setItem("localLog", []);
                    if (data && data.codigo) {
                        dataService.data.log.unshift('RECEBENDO RETORNO DO LOTE');

                        storageService.removeItem("ressincronizar");
                        $state.go('sincronizacaoInicial');

                        setTimeout(function () {
                            dataService.data.recebi = [];
                            var isErro = false;
                            var element = data;

                            dataService.data.recebi.push(element.codigo);

                            if (!element.list || element.list.length <= 0) {
                                // sleep(5000)
                                element.mensagemRetorno = 'LOTE ' + element.codigo + ' Processado com sucesso!';
                                storageService.removeItem('loteErro');
                                dataService.data.log.unshift(element.mensagemRetorno);
                                storageService.removeItem("ultimaConsulta");
                            } else {

                                element.list.forEach(function (item) {
                                    // sleep(5000)
                                    sincronizacaoService.resolverRetorno(item);
                                });

                                isErro = true;
                            }

                            dataService.data.sincronizar = false;
                            if (!isErro) {
                                DB.query("DELETE FROM erroDomicilio;", []).then(function () {
                                    DB.query("DELETE FROM erroPaciente;", []).then(function () {
                                        sincronizacaoService.porFiltro();
                                    });
                                });
                                
                                importacaoService.limparCodigoNullDominio();
                            } else {
                                dataService.data.avancar = true;
                                /// Controla para que o recurso de receber reposta do backend rode um por vez.
                                dataService.data.processando = false;
                                storageService.removeItem("confirmandoLote");
                                storageService.removeItem("ultimaConsulta");
                            }

                        }, 1000);

                    } else {
                        /// Controla para que o recurso de receber reposta do backend rode um por vez.
                        dataService.data.processando = false;
                    }
                }, function () {
                    messageService.entregaErros(messageService.mensagensErro.COMUNICACAO_SERVIDOR);
                    dataService.data.processando = false;
                });
            }
        }
    };

    sincronizacaoService.setParentScope = function (parentScope) {
        sincronizacaoService.parentScope = parentScope;
    };

    sincronizacaoService.resolverRetorno = function (retorno) {
        // var deferred = $q.defer();
        var self = this;

        self.updateRetorno = function (retorno) {

            var obj = retorno;
            var entidade = obj.entidade || obj.nomeRecurso;
            delete dataService.data.voltar;
            dataService.data.erros = [];
            importacaoService.chamaRespondeu().then(function () {

                dataService.data.possuiErros = true;
                dataService.data.avancar = true;
                dataService.data.desabilita = false;
                storageService.removeItem("desabilita");
                storageService.setItem("ressincronizar", false);
                dataService.data.processando = false;

                if (!!obj.codigoLote) {
                    storageService.setItem('loteErro', obj.codigoLote);
                    storageService.removeItem('solicitado');
                    sincronizacaoService.parentScope.loteErro = obj.codigoLote;
                    dataService.data.erros.push('PROBLEMAS AO PROCESSAR O LOTE: ' + obj.codigoLote);
                }
                
                dataService.data.erros.push(entidade + ': ' + obj.msg);

                if (!entidade) {
                    obj.msg = messageService.mensagensErro.SUPORTE;
                    dataService.data.erros.push('Recurso desconhecido: ' + obj.msg);
                    console.log(obj)
                    return;
                } else if(obj.msg === "A consulta retornou mais de um registro onde esperava-se somente um. (Verifique se o ID do objeto está completo)"){
                    obj.msg = messageService.mensagensErro.SUPORTE;
                    dataService.data.erros.push('Recurso desconhecido: ' + obj.msg);
                    console.log(obj)
                }

                storageService.setItem("ultimoErro", JSON.stringify(dataService.data.erros));

                dataService.data.erros = dataService.data.erros.filter(function (elem, index, self) {
                    return index == self.indexOf(elem);
                });
            
                if (entidade === 'endereco') {

                    DB.query("SELECT d.id FROM domicilio AS d WHERE d.codigoEndereco = ? LIMIT 1", [obj.codigoMobile]).then(function (result) {
                        var domicilio = DB.fetch(result);
                        DB.query("INSERT OR IGNORE INTO erroDomicilio (codigoDomicilio, mensagem) VALUES (?, ?)", [domicilio.id, obj.msg]).then(function () {
                        });
                    });
                } else if (entidade === 'domicilio') {

                    DB.query("INSERT OR IGNORE INTO erroDomicilio (codigoDomicilio, mensagem) VALUES (?, ?)", [obj.codigoMobile, obj.msg]).then(function () {
                    });
                } else if (entidade === 'domicilio_esus') {

                    DB.query("SELECT d.id FROM domicilioEsus AS de LEFT JOIN domicilio AS d ON d.id = de.codigoDomicilio WHERE de.id = ? ", [obj.codigoMobile]).then(function (result) {
                        var domicilio = DB.fetch(result);
                        DB.query("INSERT OR IGNORE INTO erroDomicilio (codigoDomicilio, mensagem) VALUES (?, ?)", [domicilio.id, obj.msg]).then(function () {
                        });
                    });
                } else if (entidade === 'pacientev2') {

                    DB.query("INSERT OR IGNORE INTO erroPaciente (codigoPaciente, mensagem) VALUES (?, ?)", [obj.codigoMobile, obj.msg]).then(function () {
                    });

                } else if (entidade === 'paciente_esus') {

                    DB.query("SELECT p.id FROM pacienteEsus AS pe LEFT JOIN paciente AS p ON p.id = pe.codigoPaciente WHERE pe.id = ? ", [obj.codigoMobile]).then(function (result) {
                        var paciente = DB.fetch(result);
                        DB.query("INSERT OR IGNORE INTO erroPaciente (codigoPaciente, mensagem) VALUES (?, ?)", [paciente.id, obj.msg]).then(function () {
                        });
                    });

                } else if (entidade === 'cns') {

                    DB.query("SELECT p.id FROM cns AS cns LEFT JOIN paciente AS p ON p.id = cns.codigoPaciente WHERE cns.id = ? ", [obj.codigoMobile]).then(function (result) {
                        var paciente = DB.fetch(result);
                        DB.query("INSERT OR IGNORE INTO erroPaciente (codigoPaciente, mensagem) VALUES (?, ?)", [paciente.id, obj.msg]).then(function () {
                        });
                    });

                } else if (entidade === 'documentos') {

                    DB.query("SELECT p.id FROM documentos AS doc LEFT JOIN paciente AS p ON p.id = doc.codigoPaciente WHERE doc.id = ? ", [obj.codigoMobile]).then(function (result) {
                        var paciente = DB.fetch(result);
                        DB.query("INSERT OR IGNORE INTO erroPaciente (codigoPaciente, mensagem) VALUES (?, ?)", [paciente.id, obj.msg]).then(function () {
                        });
                    });

                }
            }, function () {
                messageService.entregaErros(messageService.mensagensErro.COMUNICACAO_SERVIDOR);
            });
        };

        self.updateRetorno(retorno);

    };
    sincronizacaoService.problemaConexao = importacaoService.problemaConexao;

    sincronizacaoService.porFiltro = function () {
        DB.deleteVersionTriggers().then(function () {
            var tablesToDrop = ['cns', 'documentos', 'notificacaoPaciente', 'pacienteDado', 'notificacaoAgendas', 'registroVacinas', 'pacienteResponsavelAux', 'pacienteEsus', 'domicilioEsus', 'pesquisaVisita', 'visitaDomiciliar', 'vacinasImagens', 'paciente', 'domicilio', 'endereco'];
            var sql = '';

            tablesToDrop.forEach(function (item) {
                sql = sql + 'DELETE FROM ' + item + ' ;|';
            });

            sql = sql.split('|');
            var contador = 0;

            sql.forEach(function (item) {
                contador++;
                var currentTable = item.split(' ')[2];
                if (currentTable) {
                    if (!dataService.data.log) {
                        dataService.data.log = [];
                    }
                    dataService.data.log.unshift('Limpando ' + currentTable);
                }
                if (contador === sql.length - 1) {
                    DB.query(item, []).then(function () {
                        sincronizacaoService.carregarVersoes();
                        // alert("OK")
                    }, function (e) {
                        messageService.entregaErros(messageService.mensagensErro.SUPORTE, e);
                    });
                } else if (contador <= sql.length - 1) {
                    DB.query(item, []).then(function () {}, function (e) {
                        messageService.entregaErros(messageService.mensagensErro.SUPORTE, e);
                    });
                }
            });

        });
    };

    sincronizacaoService.carregarVersoes = function () {
        delete dataService.data.voltar;
        dataService.data.erros = [];
        $resource(dataService.data.url + G_versao + '/' + G_id + '/consultarVersoes/' + storageService.getItem("codigoProfissional")).get(function (result) {
            dataService.data.bind.domicilio = result.domicilio; //Nao esta sendo usado
            dataService.data.bind.domicilioEsus = result.domicilioEsus;
            dataService.data.bind.paciente = result.paciente; //Nao esta sendo usado
            dataService.data.bind.pacienteEsus = result.pacienteEsus;
            dataService.data.bind.cns = result.cns;
            dataService.data.bind.documentos = result.documentos;
            dataService.data.bind.pacienteDado = result.pacienteDado;

            importacaoService.init();
        }, function (data) {
            if (!data.data) {
                messageService.entregaErros(messageService.mensagensErro.COMUNICACAO_SERVIDOR);
            } else {
                messageService.entregaErros(messageService.mensagensErro.SUPORTE, data.data);
            }
        });
    };

    return sincronizacaoService;

});